diff -pruN 0.18.debian8/.bzr-builddeb/default.conf 0.46ubuntu1/.bzr-builddeb/default.conf
--- 0.18.debian8/.bzr-builddeb/default.conf	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/.bzr-builddeb/default.conf	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-[BUILDDEB]
-native = True
diff -pruN 0.18.debian8/COPYING 0.46ubuntu1/COPYING
--- 0.18.debian8/COPYING	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/COPYING	2020-08-13 20:47:40.000000000 +0000
@@ -77,7 +77,7 @@ modification follow.
 
   "Copyright" also means copyright-like laws that apply to other kinds of
 works, such as semiconductor masks.
- 
+
   "The Program" refers to any copyrightable work licensed under this
 License.  Each licensee is addressed as "you".  "Licensees" and
 "recipients" may be individuals or organizations.
@@ -510,7 +510,7 @@ actual knowledge that, but for the paten
 covered work in a country, or your recipient's use of the covered work
 in a country, would infringe one or more identifiable patents in that
 country that you have reason to believe are valid.
-  
+
   If, pursuant to or in connection with a single transaction or
 arrangement, you convey, or propagate by procuring conveyance of, a
 covered work, and grant a patent license to some of the parties
diff -pruN 0.18.debian8/copymods/hooks/copymods 0.46ubuntu1/copymods/hooks/copymods
--- 0.18.debian8/copymods/hooks/copymods	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/copymods/hooks/copymods	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,15 @@
+#!/bin/sh
+set -e
+
+prereqs() {
+	local o="/scripts/init-bottom/overlayroot"  p=""
+	for p in "$DESTDIR/" ""; do
+		[ -e "$p$o" ] && echo "overlayroot" && return 0
+	done
+}
+
+[ "$1" = "prereqs" ] && { prereqs; exit; }
+
+. /usr/share/initramfs-tools/hook-functions
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/copymods/scripts/init-bottom/copymods 0.46ubuntu1/copymods/scripts/init-bottom/copymods
--- 0.18.debian8/copymods/scripts/init-bottom/copymods	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/copymods/scripts/init-bottom/copymods	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,69 @@
+#!/bin/sh
+#  Copyright, 2014 Scott Moser <smoser@ubuntu.com>
+#
+#  This program is free software: you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation, either version 3 of the License, or
+#  (at your option) any later version.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see
+#    <http://www.gnu.org/licenses/>.
+
+prereqs() {
+	local o="/scripts/init-bottom/overlayroot"  p=""
+	# basically we run after overlayroot but do not depend on it
+	for p in "$DESTDIR/" ""; do
+		[ -e "$p$o" ] && echo "overlayroot" && return 0
+	done
+}
+
+[ "$1" != "prereqs" ] || { prereqs; exit; }
+
+. /scripts/functions
+
+set -f
+PATH=/usr/sbin:/usr/bin:/sbin:/bin
+
+cmdline=""
+myopts=""
+if [ -f /proc/cmdline ]; then
+	read cmdline < /proc/cmdline
+	for tok in $cmdline; do
+		[ "${tok#copymods=}" != "$tok" ] || continue
+		myopts="${tok#copymods=}"
+	done
+fi
+myver=$(uname -r)
+
+if [ ! -d "/lib/modules/$myver" ]; then
+	log_warning_msg "Something odd, no /lib/modules/$myver in initramfs."
+	exit 0
+fi
+
+[ -d "$rootmnt/lib/modules" ] || mkdir -p "$rootmnt/lib/modules" ||
+	{ log_warning_msg "No /lib/modules in target. cannot help."; exit 0; }
+
+if [ -d "$rootmnt/lib/modules/$myver" ]; then
+	if [ "${myopts#*force}" = "$myopts" ]; then
+		exit 0
+	else
+		log_warning_msg "copying over existing modules! due to copymods=force"
+	fi
+fi
+
+mount -t tmpfs copymods "$rootmnt/lib/modules" ||
+	{ log_failure_msg "failed mount of tmpfs"; exit 0; }
+
+mv "/lib/modules/$myver" "$rootmnt/lib/modules" ||
+	{ log_failure_msg "failed to copy modules to target root"; exit 0; }
+
+ln -s "$rootmnt/lib/modules/$myver" "/lib/modules/$myver" ||
+	{ log_failure_msg "failed to link to modules"; exit 0; }
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/debian/changelog 0.46ubuntu1/debian/changelog
--- 0.18.debian8/debian/changelog	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/changelog	2020-08-13 20:47:40.000000000 +0000
@@ -1,74 +1,244 @@
-cloud-initramfs-tools (0.18.debian8) unstable; urgency=medium
+cloud-initramfs-tools (0.46ubuntu1) groovy; urgency=medium
 
-  [ Thomas Goirand ]
-  * Remove Julien Danjou from uploaders (Closes: #928563).
+  * overlayroot: initialize /etc/fstab if root does not have one and
+    read-only [Scott Moser] (LP: #1890803)
 
-  [ Noah Meyerhans ]
-  * Update Vcs-* link in debian/control
-  * Update standards version to 4.5.0 (no changes needed)
-  * Spelling and other misc fixes in debian/control
+ -- Scott Moser <smoser@ubuntu.com>  Thu, 13 Aug 2020 16:47:40 -0400
 
- -- Noah Meyerhans <noahm@debian.org>  Tue, 10 Mar 2020 17:30:21 -0700
+cloud-initramfs-tools (0.45ubuntu1) focal; urgency=medium
 
-cloud-initramfs-tools (0.18.debian7) unstable; urgency=medium
+  * Add dependency on flock for growroot's use of growpart.
+    (LP: #1834875)
 
-  * Add patch for resizing mmcblkXpY type partitions. (Closes: #924113)
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 25 Feb 2020 13:08:22 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Sat, 09 Mar 2019 18:46:31 +0100
+cloud-initramfs-tools (0.44ubuntu1) disco; urgency=medium
 
-cloud-initramfs-tools (0.18.debian6) unstable; urgency=medium
+  [ Dann Frazier ]
+  * copymods: Fix usage of modules in initramfs after copymods script.
+    (LP: #1766723)
+  * copymods: Fix typo parsing copymods= parameters in /proc/cmdline.
 
-  * Update path of udevadm to /bin (instead of /sbin). (Closes: #852569)
-  * Depends on fdisk. (Closes: #872102)
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 13 Nov 2018 10:09:46 -0500
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 28 Sep 2017 11:20:36 +0200
+cloud-initramfs-tools (0.43ubuntu1) cosmic; urgency=medium
 
-cloud-initramfs-tools (0.18.debian5) unstable; urgency=medium
+  [ Robert Jennings ]
+  * copymods: Take ownership of lib/modules (LP: #1792905)
+  * debian/control: Update Vcs-* to point to git.
 
-  * Add myself in Uploaders
-  * copy /bin/readlink in the initrd to be able to use the -f parameter
-    as expected by growroot (Closes: #744822)
+ -- Scott Moser <smoser@ubuntu.com>  Thu, 20 Sep 2018 08:43:53 -0400
 
- -- Gonéri Le Bouder <goneri@debian.org>  Tue, 15 Apr 2014 01:48:56 +0200
+cloud-initramfs-tools (0.42ubuntu1) cosmic; urgency=medium
 
-cloud-initramfs-tools (0.18.debian4) unstable; urgency=medium
+  * debian/control: fix lintian warnings
+    ancient-standards-version (3.9.3 -> 4.1.5),
+    spelling-error-in-description,
+    priority-extra-is-replaced-by-priority-optional
+  * debian/copyright: fix lintian missing-license-paragraph-in-dep5-copyright
+  * debian/compat fix lintian
+    package-uses-deprecated-debhelper-compat-version (7 -> 11)
 
-  * Removed the overlayroot package, because there's no kernel module available
-    in Debian to support it (Closes: #732788).
-  * Bumps Standards-Version: to 3.9.5.
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 10 Jul 2018 10:20:50 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Fri, 28 Feb 2014 13:04:19 +0800
+cloud-initramfs-tools (0.41ubuntu1) cosmic; urgency=medium
 
-cloud-initramfs-tools (0.18.debian3) unstable; urgency=low
+  * growroot: copy_exec from wherever they were in path. Closes #852569.
+  * overlayroot: Make overlay mount 'noauto' if backing mount is 'noauto'.
+    (LP: #1779279)
 
-  * Removed patch for disabling growpart checkups.
-  * Added "rm" in the growpart requires.
-  * cloud-initramfs-growroot now needs cloud-utils >= 0.26-2~ (since this is
-    the version containing the fix for the growpart trap).
-  * Bumps Standards-Version: to 3.9.4.
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 10 Jul 2018 09:15:28 -0400
 
- -- Thomas Goirand <zigo@debian.org>  Thu, 13 Jun 2013 06:59:38 +0000
+cloud-initramfs-tools (0.40ubuntu1) bionic; urgency=medium
 
-cloud-initramfs-tools (0.18.debian2) unstable; urgency=low
+  * rooturl: adjust squashfs url matching to not require '.'.
+    Previously it would match <url>*.squashfs or <url>*.squash
+    Now it will match <url>*squashfs or <url>*.squash.
+    (LP: #1728048)
+  * overlayroot: Comment out the read-only line for /.  This hopes to
+    avoid systemd confusion and transient ordering cycle. (LP: #1723183)
 
-  [ Julien Danjou ]
-  * Fix Vcs-Git field (Closes: #705474)
+ -- Scott Moser <smoser@ubuntu.com>  Fri, 27 Oct 2017 09:44:49 -0400
 
-  [ Thomas Goirand ]
-  * Remove the check for the growpart --dry-run which made everything fail.
-  * Added a debian/gbp.conf to have the debian/unstable branch as default.
-  * Adds sed and awk in the initramfs (without it, growpart fails).
-  * Added myself as uploader.
-  * Added patch descrtion (patch from Julien).
-  * Reviewed/reformated a bit the debian/copyright file.
+cloud-initramfs-tools (0.39ubuntu1) artful; urgency=medium
 
- -- Thomas Goirand <zigo@debian.org>  Sun, 26 May 2013 22:51:56 +0800
+  * overlayroot, rooturl: fix usage of log_warning_msg. 
 
-cloud-initramfs-tools (0.18.debian1) unstable; urgency=low
+ -- Scott Moser <smoser@ubuntu.com>  Thu, 31 Aug 2017 16:12:43 -0400
 
-  * Package for Debian
+cloud-initramfs-tools (0.38ubuntu1) artful; urgency=medium
 
- -- Julien Danjou <acid@debian.org>  Tue, 29 Jan 2013 14:14:00 +0100
+  * overlayroot: add 'noauto' to the options for the /media/root-ro 
+    fstab entry (LP: #1666573).
+
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 13 Jun 2017 16:52:16 -0400
+
+cloud-initramfs-tools (0.37ubuntu1) artful; urgency=medium
+
+  * Remove unintended files from source upload.
+  * remove trailing white space in many files.
+
+ -- Scott Moser <smoser@ubuntu.com>  Thu, 11 May 2017 15:45:18 -0400
+
+cloud-initramfs-tools (0.36ubuntu1) artful; urgency=medium
+
+  * cloud-initramfs-rooturl: add squashfs module to initramfs
+    via manual_add_modules (LP: #1689642).
+
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 09 May 2017 16:12:35 -0400
+
+cloud-initramfs-tools (0.35ubuntu1) zesty; urgency=medium
+
+  * add cloud-initramfs-updateroot package.
+
+ -- Scott Moser <smoser@ubuntu.com>  Wed, 11 Jan 2017 09:45:46 -0500
+
+cloud-initramfs-tools (0.34ubuntu1) zesty; urgency=medium
+
+  * cloud-initramfs-rooturl: fix bug resulting in warning message
+    being written when provided a tarball as root.
+
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 10 Jan 2017 20:28:21 -0500
+
+cloud-initramfs-tools (0.33ubuntu1) zesty; urgency=medium
+
+  * add cloud-initramfs-rooturl package.
+
+ -- Scott Moser <smoser@ubuntu.com>  Fri, 09 Dec 2016 05:28:54 -0500
+
+cloud-initramfs-tools (0.32ubuntu1) zesty; urgency=medium
+
+  * overlayroot: fix overlayroot=crypt with newer initramfs-tools
+    (LP: #1634310)
+  * overlayroot: support random seed from systemd
+    systemd-random-seed.service
+
+ -- Scott Moser <smoser@ubuntu.com>  Mon, 14 Nov 2016 12:25:10 -0500
+
+cloud-initramfs-tools (0.31ubuntu1) zesty; urgency=medium
+
+  * cloud-initramfs-dyn-netconf: Further adjustments to support
+    IPV6 and the new DEVICE6 and net6-DEVICE.conf files.
+    (LP: #1621615)
+
+ -- Scott Moser <smoser@ubuntu.com>  Wed, 02 Nov 2016 15:55:39 -0400
+
+cloud-initramfs-tools (0.30ubuntu1) yakkety; urgency=medium
+
+  [ LaMont Jones ]
+  * cloud-initramfs-dyn-netconf: Fix bug in previously added IPV6
+    support. (LP: #1621615)
+
+ -- Scott Moser <smoser@ubuntu.com>  Wed, 05 Oct 2016 11:52:32 -0400
+
+cloud-initramfs-tools (0.29ubuntu2) yakkety; urgency=medium
+
+  [ LaMont Jones ]
+  * Add IPV6 support to cloud-initramfs-dyn-netconf.  (LP: #1621615)
+
+ -- LaMont Jones <lamont@canonical.com>  Tue, 27 Sep 2016 16:07:48 -0600
+
+cloud-initramfs-tools (0.29ubuntu1) yakkety; urgency=medium
+
+  * overlayroot: support 'overlay' filesystem explicitly rather than
+    relying on ubuntu specific kernel module 'overlayfs'.  (LP: #1493188)
+
+ -- Scott Moser <smoser@ubuntu.com>  Fri, 23 Sep 2016 17:00:37 -0400
+
+cloud-initramfs-tools (0.28ubuntu1) yakkety; urgency=medium
+
+  * overlayroot: write debug to /run/initramfs not /dev/.initramfs but
+    support writing to /dev/.initramfs if that is all there is. (LP: #1485752)
+  * overlayroot: fix overlayroot if recurse=0 was not provided.
+    This fuctionality was lost since workdir support was added. (LP: #1619459)
+
+ -- Scott Moser <smoser@ubuntu.com>  Fri, 02 Sep 2016 11:20:53 -0400
+
+cloud-initramfs-tools (0.27ubuntu1) wily; urgency=medium
+
+  * cloud-initramfs-dyn-netconf: bring up networking if ip is on kernel
+    command line and it has not been brought up (LP: #1463846)
+  * cloud-initramfs-copymods: do not warn to console if /lib/modules
+    exists in the target, as that is an expected case.
+
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 23 Jun 2015 12:46:29 -0400
+
+cloud-initramfs-tools (0.26ubuntu1) vivid; urgency=medium
+
+  * cloud-initramfs-dyn-netconf: support BOOTIF= that contains
+    upper case a-f.
+  * overlayroot: use required 'workdir' option on overlayfs mount for
+    kernels >= 3.18 (LP: #1411294)
+
+ -- Scott Moser <smoser@ubuntu.com>  Fri, 16 Jan 2015 12:01:06 -0500
+
+cloud-initramfs-tools (0.25ubuntu1) trusty; urgency=medium
+
+  * cloud-initramfs-copymods: Add new package that is useful
+    if you're booting kernel/initramfs that live external to
+    the root filesystem.
+
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 25 Mar 2014 17:22:34 -0400
+
+cloud-initramfs-tools (0.24ubuntu1) trusty; urgency=medium
+
+  * overlayroot: package conf-hooks.d/overlayroot which was previously
+    not included in the package.
+
+ -- Scott Moser <smoser@ubuntu.com>  Wed, 12 Feb 2014 13:31:57 -0500
+
+cloud-initramfs-tools (0.23ubuntu1) trusty; urgency=low
+
+   [ Dimitri John Ledkov ]
+   * modify overlayroot config to export CRYPTSETUP=yes so that
+     crypto modules are included by cryptsetup. (LP: #1267225)
+
+ -- Scott Moser <smoser@ubuntu.com>  Wed, 05 Feb 2014 15:13:58 +0200
+
+cloud-initramfs-tools (0.22ubuntu1) trusty; urgency=medium
+
+  * correctly identify partition and block device for devices named
+    like devnameXpN, such as mmcblk0p1 (LP: #1236380).
+  * always include aesni_intel rather than doing it if there is
+    cpu support (LP: #1267225).
+
+ -- Scott Moser <smoser@ubuntu.com>  Mon, 03 Feb 2014 22:09:00 +0200
+
+cloud-initramfs-tools (0.21ubuntu2) trusty; urgency=low
+
+  * Fix Makefile to avoid FTBS caused by subdir in overlayroot/etc
+    Makefile now takes into account when subdirectories are present in
+    the overlayroot directory.
+
+ -- Louis Bouchard <louis.bouchard@ubuntu.com>  Thu, 02 Jan 2014 03:26:22 +0000
+
+cloud-initramfs-tools (0.21ubuntu1) trusty; urgency=low
+
+  * === added directory overlayroot/etc/update-motd.d,
+    debian/overlayroot.install, overlayroot/etc/update-motd.d/97-
+    overlayroot:
+    - add an update-motd message, when booted in an overlayroot
+      environment
+
+ -- Dustin Kirkland <kirkland@ubuntu.com>  Fri, 15 Nov 2013 12:05:58 -0600
+
+cloud-initramfs-tools (0.20ubuntu1) saucy; urgency=low
+
+  * debian/control: depend on cloud-utils or cloud-guest-utils.
+  * overlayroot: include a fix for creating /etc/init in overlay so
+    inotify works correctly.
+
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 27 Aug 2013 16:48:53 -0400
+
+cloud-initramfs-tools (0.19ubuntu1) raring; urgency=low
+
+  * cloud-initramfs-growroot: support growpart exit status of '1'
+    indicating "no-change-necessary"
+  * cloud-initramfs-dyn-netconf: run at init-premount rather than
+    init-top to ensure that 'load_modules' has been run and udev is
+    running (LP: #1116426)
+
+ -- Scott Moser <smoser@ubuntu.com>  Tue, 05 Feb 2013 16:49:23 -0500
 
 cloud-initramfs-tools (0.18-ubuntu1) quantal; urgency=low
 
diff -pruN 0.18.debian8/debian/cloud-initramfs-copymods.dirs 0.46ubuntu1/debian/cloud-initramfs-copymods.dirs
--- 0.18.debian8/debian/cloud-initramfs-copymods.dirs	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-copymods.dirs	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1 @@
+lib/modules
diff -pruN 0.18.debian8/debian/cloud-initramfs-copymods.install 0.46ubuntu1/debian/cloud-initramfs-copymods.install
--- 0.18.debian8/debian/cloud-initramfs-copymods.install	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-copymods.install	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,2 @@
+usr/share/initramfs-tools/hooks/copymods
+usr/share/initramfs-tools/scripts/*/copymods
diff -pruN 0.18.debian8/debian/cloud-initramfs-copymods.postinst 0.46ubuntu1/debian/cloud-initramfs-copymods.postinst
--- 0.18.debian8/debian/cloud-initramfs-copymods.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-copymods.postinst	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,13 @@
+#!/bin/sh
+set -e
+
+case "$1" in
+	configure)
+		dpkg-trigger update-initramfs;;
+	*) exit 0;;
+esac
+
+#DEBHELPER#
+exit 0
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/debian/cloud-initramfs-copymods.postrm 0.46ubuntu1/debian/cloud-initramfs-copymods.postrm
--- 0.18.debian8/debian/cloud-initramfs-copymods.postrm	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-copymods.postrm	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,14 @@
+#!/bin/sh
+set -e
+
+case "$1" in
+	remove|purge)
+		dpkg-trigger update-initramfs;;
+	*) exit 0;;
+esac
+
+#DEBHELPER#
+exit 0
+
+# vi: ts=4 noexpandtab
+
diff -pruN 0.18.debian8/debian/cloud-initramfs-rooturl.install 0.46ubuntu1/debian/cloud-initramfs-rooturl.install
--- 0.18.debian8/debian/cloud-initramfs-rooturl.install	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-rooturl.install	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,2 @@
+usr/share/initramfs-tools/hooks/rooturl
+usr/share/initramfs-tools/scripts/*/rooturl
diff -pruN 0.18.debian8/debian/cloud-initramfs-rooturl.postinst 0.46ubuntu1/debian/cloud-initramfs-rooturl.postinst
--- 0.18.debian8/debian/cloud-initramfs-rooturl.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-rooturl.postinst	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,13 @@
+#!/bin/sh
+set -e
+
+case "$1" in
+	configure)
+		dpkg-trigger update-initramfs;;
+	*) exit 0;;
+esac
+
+#DEBHELPER#
+exit 0
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/debian/cloud-initramfs-rooturl.postrm 0.46ubuntu1/debian/cloud-initramfs-rooturl.postrm
--- 0.18.debian8/debian/cloud-initramfs-rooturl.postrm	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-rooturl.postrm	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,14 @@
+#!/bin/sh
+set -e
+
+case "$1" in
+	remove|purge)
+		dpkg-trigger update-initramfs;;
+	*) exit 0;;
+esac
+
+#DEBHELPER#
+exit 0
+
+# vi: ts=4 noexpandtab
+
diff -pruN 0.18.debian8/debian/cloud-initramfs-updateroot.install 0.46ubuntu1/debian/cloud-initramfs-updateroot.install
--- 0.18.debian8/debian/cloud-initramfs-updateroot.install	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-updateroot.install	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,2 @@
+usr/share/initramfs-tools/hooks/updateroot
+usr/share/initramfs-tools/scripts/*/updateroot
diff -pruN 0.18.debian8/debian/cloud-initramfs-updateroot.postinst 0.46ubuntu1/debian/cloud-initramfs-updateroot.postinst
--- 0.18.debian8/debian/cloud-initramfs-updateroot.postinst	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-updateroot.postinst	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,13 @@
+#!/bin/sh
+set -e
+
+case "$1" in
+	configure)
+		dpkg-trigger update-initramfs;;
+	*) exit 0;;
+esac
+
+#DEBHELPER#
+exit 0
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/debian/cloud-initramfs-updateroot.postrm 0.46ubuntu1/debian/cloud-initramfs-updateroot.postrm
--- 0.18.debian8/debian/cloud-initramfs-updateroot.postrm	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/cloud-initramfs-updateroot.postrm	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,14 @@
+#!/bin/sh
+set -e
+
+case "$1" in
+	remove|purge)
+		dpkg-trigger update-initramfs;;
+	*) exit 0;;
+esac
+
+#DEBHELPER#
+exit 0
+
+# vi: ts=4 noexpandtab
+
diff -pruN 0.18.debian8/debian/compat 0.46ubuntu1/debian/compat
--- 0.18.debian8/debian/compat	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/debian/compat	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1 @@
+11
diff -pruN 0.18.debian8/debian/control 0.46ubuntu1/debian/control
--- 0.18.debian8/debian/control	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/control	2020-08-13 20:47:40.000000000 +0000
@@ -1,15 +1,11 @@
 Source: cloud-initramfs-tools
 Section: admin
 Priority: optional
-Maintainer: Debian Cloud <debian-cloud@lists.debian.org>
-Uploaders:
- Thomas Goirand <zigo@debian.org>,
- Noah Meyerhans <noahm@debian.org>,
-Build-Depends: debhelper-compat (= 12), quilt
-Standards-Version: 4.5.0
+Maintainer: Scott Moser <smoser@ubuntu.com>
+Build-Depends: debhelper (>= 11)
+Standards-Version: 4.1.5
 Homepage: http://launchpad.net/cloud-initramfs-tools
-Vcs-Browser: https://salsa.debian.org/cloud-team/cloud-initramfs-tools
-Vcs-Git: https://salsa.debian.org/cloud-team/cloud-initramfs-tools.git
+Vcs-Git: https://git.launchpad.net/cloud-initramfs-tools
 
 Package: cloud-initramfs-rescuevol
 Architecture: all
@@ -20,16 +16,16 @@ Description: boot off a rescue volume ra
  with a label of 'RESCUE_VOL' are attached.  If such a volume is attached,
  it will boot off that volume rather than the root volume.
  .
- This is useful in a cloud environment, when the user is able to
- attach and detach volumes to a running system, but has no other
- mechanism for interrupting of fixing a failed boot.  It is analogous
- to inserting a rescue CD into a system to recover from failure.
+ This is useful in a cloud environment, when the user is able to attach
+ and detach volumes to a running system, but has no other mechanism
+ for interrupting of fixing a failed boot.  It is analogous to inserting
+ a rescue CD into a system to recover from failure.
 
 Package: cloud-initramfs-growroot
 Architecture: all
-Depends: cloud-utils (>= 0.26-2~),
+Depends: cloud-utils (>= 0.21ubuntu1) | cloud-guest-utils,
          initramfs-tools,
-         fdisk | util-linux (<< 2.29.2-3~),
+         util-linux (>= 2.17.2),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: automatically resize the root partition on first boot
@@ -43,22 +39,22 @@ Description: automatically resize the ro
  In this case, with this package installed, you can automatically use
  the new space without requiring a reboot to re-read the partition table.
 
-#Package: overlayroot
-#Architecture: all
-#Depends: cryptsetup,
-#         cryptsetup-bin,
-#         initramfs-tools,
-#         ${misc:Depends},
-#         ${shlibs:Depends}
-#Suggests: haveged
-#Description: use an overlayfs on top of a read-only root filesystem
-# This package adds functionality to an initramfs built by initramfs-tools.
-# When installed and configured, the initramfs will mount an overlayfs
-# filesystem on top of a read-only root volume.
-# .
-# The changes can be written to a in-memory temporary filesystem, a
-# filesystem on an existing block device, or a dmcrypt encrypted block
-# device.
+Package: overlayroot
+Architecture: all
+Depends: cryptsetup,
+         cryptsetup-bin,
+         initramfs-tools,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: haveged
+Description: use an overlayfs on top of a read-only root filesystem
+ This package adds functionality to an initramfs built by initramfs-tools.
+ When installed and configured, the initramfs will mount an overlayfs
+ filesystem on top of a read-only root volume.
+ .
+ The changes can be written to a in-memory temporary filesystem, a
+ filesystem on an existing block device, or a dmcrypt encrypted block
+ device.
 
 Package: cloud-initramfs-dyn-netconf
 Architecture: all
@@ -67,3 +63,34 @@ Description: write a network interface f
  This package provides an initramfs module that will write a simple
  network interfaces formatted file to /run/network/interfaces with
  entries for any devices that were configured during initramfs.
+
+Package: cloud-initramfs-copymods
+Architecture: all
+Depends: initramfs-tools,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Description: copy initramfs modules into root filesystem for later use
+ When booting with an external-to-root kernel and initramfs, you need
+ to ensure that /lib/modules contains any necessary modules not already
+ loaded.
+ .
+ This package arranges for the modules in the initramfs to be placed
+ into /lib/modules after the switchroot is done.
+
+Package: cloud-initramfs-rooturl
+Architecture: all
+Depends: initramfs-tools,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Description: use a tarball or squashfs image in a url as the root filesystem
+ Allows user to pass in root=http://example.com/your.tar.gz
+ Root filesystem will be tmpfs from that url.
+
+Package: cloud-initramfs-updateroot
+Architecture: all
+Depends: initramfs-tools,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Description: extract a tarball over root filesystem before pivot
+ Allows kernel command line updateroot=http://your.tar.gz
+ And then tarball will be pulled and extracted over the root.
diff -pruN 0.18.debian8/debian/copyright 0.46ubuntu1/debian/copyright
--- 0.18.debian8/debian/copyright	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/copyright	2020-08-13 20:47:40.000000000 +0000
@@ -2,35 +2,35 @@ Format: http://www.debian.org/doc/packag
 Upstream-Name: cloud-initramfs-tools
 
 Files: *
-Copyright: 2011, Scott Moser <scott.moser@canonical.com>
-License: GPL-3+
+Copyright: 2011 Scott Moser <scott.moser@canonical.com>
+License: GPL-3.0+
 
 Files: debian/* overlayroot/scripts/init-bottom/overlayroot
-Copyright: 2011, Scott Moser <smoser@ubuntu.com>
-	2013, Julien Danjou <acid@debian.org>
-	2013, Thomas Goirand <zigo@debian.org>
-License: GPL-3+
+Copyright: 2011 Scott Moser <smoser@ubuntu.com>
+License: GPL-3.0+
 
 Files: debian/*overlayroot* overlayroot/*
-Copyright: 2012, Dustin Kirkland <kirkland@ubuntu.com>
-License: GPL-3+
+Copyright: 2012 Dustin Kirkland <kirkland@ubuntu.com>
+License: GPL-3.0+
 
 Files: overlayroot/scripts/init-bottom/overlayroot
-Copyright: 2012, Axel Heider
-License: GPL-3+
+Copyright: 2012 Axel Heider
+License: GPL-3.0+
 
-License: GPL-3+
- This program is free software: you can redistribute it and/or modify it under
- the terms of the GNU General Public License as published by the Free Software
- Foundation, either version 3 of the License, or (at your option) any later
- version.
+License: GPL-3.0+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation, either version 3 of the License, or
+ (at your option) any later version.
  .
- This package is distributed in the hope that it will be useful, but WITHOUT
- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
- FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+ This package is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
  .
- You should have received a copy of the GNU General Public License along with
- this program. If not, see <http://www.gnu.org/licenses/>.
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>.
  .
- On Debian systems, the complete text of the GNU General Public License version
- 3 can be found in "/usr/share/common-licenses/GPL-3".
+ On Debian systems, the complete text of the GNU General
+ Public License version 3 can be found in "/usr/share/common-licenses/GPL-3".
+
diff -pruN 0.18.debian8/debian/gbp.conf 0.46ubuntu1/debian/gbp.conf
--- 0.18.debian8/debian/gbp.conf	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/gbp.conf	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-[DEFAULT]
-debian-branch = debian/unstable
-
-[git-buildpackage]
-export-dir = ../build-area/
diff -pruN 0.18.debian8/debian/overlayroot.install 0.46ubuntu1/debian/overlayroot.install
--- 0.18.debian8/debian/overlayroot.install	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/overlayroot.install	2020-08-13 20:47:40.000000000 +0000
@@ -1,5 +1,7 @@
 etc/overlayroot.conf
+etc/update-motd.d
 usr/sbin/overlayroot-chroot
 usr/share/initramfs-tools/hooks/overlayroot
 usr/share/initramfs-tools/scripts/*/overlayroot
+usr/share/initramfs-tools/conf-hooks.d/overlayroot
 usr/share/man/man8/overlayroot-chroot.8
diff -pruN 0.18.debian8/debian/patches/adds-sed-and-awk-in-ramfs.patch 0.46ubuntu1/debian/patches/adds-sed-and-awk-in-ramfs.patch
--- 0.18.debian8/debian/patches/adds-sed-and-awk-in-ramfs.patch	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/patches/adds-sed-and-awk-in-ramfs.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,24 +0,0 @@
-Description: Adds sed and awk binaries in the initramfs
- In Ubuntu, it seems that sed and awk are there by default, possibly in the
- built busybox. But in Debian, it's missing, and that is making growroot fail.
- This patch fixes it, until a better solution can be found.
- .
- Also fix path of udevadm.
-Author: Thomas Goirand <zigo@debian.org>
-Bug-Debian: https://bugs.debian.org/852569
-Forwarded: not-needed
-Date: 2017-09-28
-
---- a/growroot/hooks/growroot
-+++ b/growroot/hooks/growroot
-@@ -12,5 +12,9 @@
- copy_exec /sbin/sfdisk /sbin
- copy_exec /usr/bin/growpart /sbin
--copy_exec /sbin/udevadm /sbin
-+copy_exec /bin/udevadm /sbin
-+copy_exec /usr/bin/awk /bin
-+copy_exec /bin/sed /bin
-+copy_exec /bin/rm /bin
-+copy_exec /bin/readlink /bin
- 
- # vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/debian/patches/remove-wait-for-root.patch 0.46ubuntu1/debian/patches/remove-wait-for-root.patch
--- 0.18.debian8/debian/patches/remove-wait-for-root.patch	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/patches/remove-wait-for-root.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,41 +0,0 @@
-Description: remove wait for root in overlayroot init-bottom
-Author: Julien Danjou <acid@debian.org>
-Forwarded: no
-Date: 2013-01-29
-
---- a/growroot/scripts/local-bottom/growroot
-+++ b/growroot/scripts/local-bottom/growroot
-@@ -88,7 +88,11 @@
- 
- # this is taken from 'mountroot' function
- #   see /usr/share/initramfs-tools/scripts/local
--FSTYPE=$(wait-for-root "${ROOT}" ${ROOTDELAY:-30})
-+if [ -z "${ROOTFSTYPE}" ]; then
-+    FSTYPE=$(get_fstype "${ROOT}")
-+else
-+    FSTYPE=${ROOTFSTYPE}
-+fi
- roflag="-r"
- [ "${readonly}" = "y" ] || roflag="-w"
- mount ${roflag} ${FSTYPE:+-t ${FSTYPE} }${ROOTFLAGS} ${ROOT} ${rootmnt} ||
---- a/overlayroot/scripts/init-bottom/overlayroot
-+++ b/overlayroot/scripts/init-bottom/overlayroot
-@@ -137,8 +137,16 @@
- 	local dev="$1" timeout="${2:-0}"
- 	[ -b "$dev" ] && return 0
- 	[ "$timeout" = "0" ] && return 1
--	# wait-for-root writes fstype to stdout, redirect to null
--	wait-for-root "$dev" "$timeout" >/dev/null
-+        timeout=$(( ${timeout} * 10 ))
-+        while [ ! -e "$dev" ]; do
-+            /bin/sleep 0.1
-+            timeout=$(( ${timeout} - 1 ))
-+            [ ${timeout} -gt 0 ] || break
-+        done
-+	if [ ${timeout} -gt 0 ]; then
-+	    return 0
-+        fi
-+        return 1
- }
- crypto_setup() {
- 	local fstype="ext4" pass="" mapname="secure" mkfs="1" dev=""
diff -pruN 0.18.debian8/debian/patches/series 0.46ubuntu1/debian/patches/series
--- 0.18.debian8/debian/patches/series	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/patches/series	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-remove-wait-for-root.patch
-adds-sed-and-awk-in-ramfs.patch
diff -pruN 0.18.debian8/debian/README.source 0.46ubuntu1/debian/README.source
--- 0.18.debian8/debian/README.source	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/README.source	2020-08-13 20:47:40.000000000 +0000
@@ -2,8 +2,7 @@ cloud-initramfs-tools for Debian
 --------------------------------
 
 This package is maintained as a ubuntu native package, and revision
-controlled using bzr.
+controlled using git.
 
 The Upstream for this package is available at:
-  lp:cloud-initramfs-tools
-  https://code.launchpad.net/~cloud-initramfs-tools/cloud-initramfs-tools/trunk
+  git clone https://git.launchpad.net/~cloud-initramfs-tools/cloud-initramfs-tools
diff -pruN 0.18.debian8/debian/rules 0.46ubuntu1/debian/rules
--- 0.18.debian8/debian/rules	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/debian/rules	2020-08-13 20:47:40.000000000 +0000
@@ -7,4 +7,4 @@
 export DH_OPTIONS
 
 %:
-	dh $@ --with quilt
+	dh $@
diff -pruN 0.18.debian8/dyn-netconf/doc/README.txt 0.46ubuntu1/dyn-netconf/doc/README.txt
--- 0.18.debian8/dyn-netconf/doc/README.txt	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/dyn-netconf/doc/README.txt	2020-08-13 20:47:40.000000000 +0000
@@ -1,12 +1,52 @@
-This initramfs module writes /run/network/dynamic-interfaces based on
-interfaces that were brought up during initramfs.
+This initramfs module does 2 things:
+ * writes a file /run/network/dynamic-interfaces based on
+   interfaces that were brought up during initramfs.
+ * allows 'ip=' parameters on the command line to contain 'BOOTIF'
 
-It also replaces 'BOOTIF' in an ip= parameter with the name of the device.  Ie:
-  ip=::::<hostname>:BOOTIF
-gets changed to something like:
-  ip=::::<hostname>:eth0
-before configure_networking would be run
-
-If BOOTIF_DEFAULT (example 'BOOTIF_DEFAULT=eth0') is provided, but BOOTIF is
-not, then it will act as if BOOTIF was provided with the mac address of the
-given NIC.
+== /run/network/dynamic-interfaces ==
+When network devices are brought up in the initramfs, klibc's ipconfig
+tool writes files are named /run/net-<DEVNAME>.conf.  Their format is
+described in /usr/share/doc/libklibc/README.ipconfig.gz.
+
+This module translates those files to a interfaces(5) style file
+and writes that to /run/network/dynamic-interfaces.
+Each configured device is set to 'manual'.
+It writes 'dns-nameservers' and 'dns-search' entries as supported
+by resolvconf(8).
+
+The end result of this is that if you were only interested in interfaces
+configured in the initramfs, you could have /etc/network/interfaces be a
+symlink to /run/network/dynamic-interfaces.   Then, the
+static-networking event will fire correctly as all configured network
+devices will already be up, and configured network interfaces will
+not be "bounced".
+
+This is how the maas ephemeral images function in 12.04 and 12.10.  These
+images are used to netboot to a read-only from iscsi root device.
+
+=== 'ip=' and BOOTIF manipulation ===
+When executed in the initramfs, the code in
+'init-top/cloud-initramfs-dyn-netconf' will modify the global 'IP' and
+'BOOTIF' variables according to the following rules:
+
+ * if BOOTIF_DEFAULT=<name> is provided on the command line, but BOOTIF is
+   not present, then BOOTIF will be set appropriately as if it were
+   specified on the kernel command line with the MAC address of the
+   device named 'name'.  Example:
+     BOOTIF_DEFAULT=eth0
+   will set the value of BOOTIF to be:
+     BOOTIF=01-00-22-68-10-c1-e6
+
+   Code that executes later in the initramfs will simply behave as if
+   BOOTIF were on the command line initially.
+
+ * if the literal string 'BOOTIF' appears inside the value of 'IP'
+   (which is set from kernel command line parameter 'ip=...'), then
+   it will be replaced with the device name that maps to the mac address
+   specified in BOOTIF.
+
+   Example:
+     ip=::::foobar:BOOTIF BOOTIF=01-00-22-68-10-c1-e6
+   will be effectively rendered as:
+     ip=::::foobar:eth0
+   before configure_networking would be run
diff -pruN 0.18.debian8/dyn-netconf/scripts/init-bottom/cloud-initramfs-dyn-netconf 0.46ubuntu1/dyn-netconf/scripts/init-bottom/cloud-initramfs-dyn-netconf
--- 0.18.debian8/dyn-netconf/scripts/init-bottom/cloud-initramfs-dyn-netconf	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/dyn-netconf/scripts/init-bottom/cloud-initramfs-dyn-netconf	2020-08-13 20:47:40.000000000 +0000
@@ -30,17 +30,79 @@ PATH=/usr/sbin:/usr/bin:/sbin:/bin
 #DHCPLEASETIME='3600'
 #DOMAINSEARCH=''
 
+# superseded by isc-dhcp and such writing the file and supporting IPv6:
+#DEVICE=eno1
+#HOSTNAME=
+#DNSDOMAIN=
+#reason='PREINIT'
+#interface='eno1'
+#DEVICE=eno1
+#HOSTNAME=
+#DNSDOMAIN=
+#reason='FAIL'
+#interface='eno1'
+#DEVICE=eno1
+#HOSTNAME=
+#DNSDOMAIN=
+#reason='PREINIT6'
+#interface='eno1'
+#DEVICE=eno1
+#IPV6PROTO=dhcp6
+#IPV6ADDR=2001:67c:1562:8010:1::4324
+#IPV6NETMASK=64
+#IPV6DNS0=2001:67c:1562:8010::2:1
+#IPV6DOMAINSEARCH=
+#HOSTNAME=
+#DNSDOMAIN=
+#reason='BOUND6'
+#interface='eno1'
+#new_ip6_address='2001:67c:1562:8010:1::4324'
+#new_ip6_prefixlen='64'
+#new_dhcp6_name_servers='2001:67c:1562:8010::2:1'
+
+
 error() { echo "${0##*/}:" "$@" 1>&2; }
-tmpf="/tmp/${0##*/}.ni"
+configure_net_if_needed() {
+	# we want to call configure_networking if and only if ip= was seen
+	# on the command line (LP: #1463846)
+	local ip="$1"
+	# empty 'ip' or ip=none or ip=off specifically mean do not bring up
+	if [ -z "$ip" ]; then
+		return 0
+	fi
+	case "$ip" in
+		none|off) return 0;;
+	esac
+	# configure_networking does not set any flags indicating it tried
+	# to run and failed, so we can only look for indication
+	# that ipconfig ran, which creates files in /run/net-<device>.conf
+	#
+	# configure_networking does a check like this.  however, its check is
+	# broken in the event that BOOTIF is not found on the command line.
+	for f in /run/net-*.conf /tmp/net-*.conf; do
+		if [ -f "$f" ]; then
+			return 0
+		fi
+	done
+
+	configure_networking
+}
+
+ni_header() {
+	echo "## This file is generated by cloud-initramfs-dyn-netconf"
+	echo "auto lo"
+	echo "iface lo inet loopback"
+}
 
-{
-echo "## This file is generated by cloud-initramfs-dyn-netconf"
-echo "auto lo"
-echo "iface lo inet loopback"
-} > "$tmpf"
 
+configure_net_if_needed "$IP" ||
+   echo "WARN: ${0##*/}: configure_networking failed" 1>&2
+
+tmpf="/tmp/${0##*/}.ni"
+
+ni_header > "$tmpf"
 seen=","
-for f in /run/net-*.conf /tmp/net-*.conf; do
+for f in /run/net-*.conf /tmp/net-*.conf /run/net6-*.conf; do
 	[ -f "$f" ] || continue
 	dev=${f#*/net-}; dev=${dev%.conf};
 	# perhaps we saw this device from /run and now we're in /tmp
@@ -50,38 +112,86 @@ for f in /run/net-*.conf /tmp/net-*.conf
 
 	DEVICE=""; PROTO=""; IPV4ADDR=""; IPV4NETMASK=""; IPV4GATEWAY="";
 	IPV4DNS0=""; IPV4DNS1=""; DNSDOMAIN=""; DOMAINSEARCH=""; filename="";
+	DEVICE6=""; IPV4PROTO=""; IPV6PROTO=""; IPV6ADDR=""; IPV6NETMASK="";
+	IPV6GATEWAY=""; IPV6DNS0=""; IPV6DNS1=""; IPV6DOMAINSEARCH="";
 	. "$f"
 
 	if [ -z "$DEVICE" ]; then
-		error "WARNING: $f had no 'DEVICE' set"
-		continue
+		if [ -z "$DEVICE6" ]; then
+		    error "WARNING: $f had no 'DEVICE' or 'DEVICE6' set"
+		    continue
+		else
+		    DEVICE="$DEVICE6"
+		fi
+	fi
+	# If IPv6 is supported, we get both of these, and at least one of them
+	# is set.  If we get both, use IPv4.
+	# Prior to that, PROTO was used, so we know it's IPv4 we want.
+	if [ -z "$IPV4PROTO" -a -z "$IPV6PROTO" ]; then
+		IPV4PROTO="$PROTO"
 	fi
 	# ipconfig on precise does not write PROTO.
-	if [ -z "$PROTO" ]; then
+	if [ -z "$IPV4PROTO" -a -z "$IPV6PROTO" ]; then
 		if [ -n "$filename" ]; then
-			PROTO="dhcp"
+			IPV4PROTO="dhcp"
 		else
-			PROTO="static"
+			IPV4PROTO="static"
 		fi
 	fi
 
+	# We need to use care, since the script is running set -e.
 	echo "manual $DEVICE"
-	if [ "$PROTO" = "dhcp" ]; then
+	if [ "$IPV4PROTO" = "dhcp" ]; then
 		echo "iface $DEVICE inet dhcp"
-	elif [ "$PROTO" = "static" ]; then
+	elif [ "$IPV4PROTO" = "static" ]; then
 		echo "iface $DEVICE inet static"
-		[ -n "$IPV4ADDR" ] && printf "\t%s\n" "address $IPV4ADDR"
-		[ -n "$IPV4NETMASK" ] && printf "\t%s\n" "netmask $IPV4NETMASK"
-		[ -n "$IPV4GATEWAY" ] && printf "\t%s\n" "gateway $IPV4GATEWAY"
+		if [ -n "$IPV4ADDR" ]; then
+			printf "\t%s\n" "address $IPV4ADDR"
+		else
+			error "WARNING: $f static with no address"
+		fi
+		if [ -n "$IPV4NETMASK" ]; then
+			printf "\t%s\n" "netmask $IPV4NETMASK"
+		else
+			error "WARNING: $f static with no netmask"
+		fi
+		if [ -n "$IPV4GATEWAY" ]; then
+			printf "\t%s\n" "gateway $IPV4GATEWAY"
+		fi
+	elif [ "$IPV6PROTO" = "dhcp6" ]; then
+		echo "iface $DEVICE inet6 dhcp"
+	elif [ "$IPV6PROTO" = "static" ]; then
+		echo "iface $DEVICE inet6 static"
+		if [ -n "$IPV6ADDR" ]; then
+			printf "\t%s\n" "address $IPV6ADDR"
+		else
+			error "WARNING: $f static with no address"
+		fi
+		if [ -n "$IPV6NETMASK" ]; then
+			printf "\t%s\n" "netmask $IPV6NETMASK"
+		else
+			error "WARNING: $f static with no netmask"
+		fi
+		if [ -n "$IPV6GATEWAY" ]; then
+			printf "\t%s\n" "gateway $IPV6GATEWAY"
+		fi
 	fi
+
+	nsline=""
 	if [ -n "$IPV4DNS0" -a "$IPV4DNS0" != "0.0.0.0" ]; then
-		nsline="dns-nameservers ${IPV4DNS0}"
-		[ -n "$IPV4DNS1" -a "$IPV4DNS1" != "0.0.0.0" ] &&
+		nsline="${IPV4DNS0}"
+		if [ -n "$IPV4DNS1" -a "$IPV4DNS1" = "0.0.0.0" ]; then
 			nsline="${nsline} ${IPV4DNS1}"
-		printf "\t%s\n" "$nsline"
+		fi
+	elif [ -n "$IPV6DNS0" ]; then
+		nsline="${nsline} ${IPV6DNS0}"
+		[ -z "$IPV6DNS1" ] || nsline="${nsline} ${IPV6DNS1}"
+	fi
+	[ -z "$nsline" ] || printf "\tdns-nameservers %s\n" "$nsline"
+	if [ -n "${DNSDOMAIN}${DOMAINSEARCH}${IPV6DOMAINSEARCH}" ]; then
+		SEARCH=" ${DNSDOMAIN} ${DOMAINSEARCH} ${IPV6DOMAINSEARCH}"
+		printf "\tdns-search %s\n" "${SEARCH}"
 	fi
-	[ -n "$DNSDOMAIN" -o -n "$DOMAINSEARCH" ] &&
-		printf "\t%s\n" "dns-search ${DNSDOMAIN} ${DOMAINSEARCH}"
 done >> "$tmpf"
 
 [ -d /run/network ] || mkdir /run/network
diff -pruN 0.18.debian8/dyn-netconf/scripts/init-premount/cloud-initramfs-dyn-netconf 0.46ubuntu1/dyn-netconf/scripts/init-premount/cloud-initramfs-dyn-netconf
--- 0.18.debian8/dyn-netconf/scripts/init-premount/cloud-initramfs-dyn-netconf	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/dyn-netconf/scripts/init-premount/cloud-initramfs-dyn-netconf	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,133 @@
+#!/bin/sh
+set -e
+set -f
+
+PREREQS="udev"
+case $1 in
+	prereqs) echo "${PREREQS}"; exit 0;;
+esac
+
+. /scripts/functions
+
+PATH=/usr/sbin:/usr/bin:/sbin:/bin
+
+error() { echo "${0##*/}:" "$@" 1>&2; }
+fail() { [ $# -eq 0 ] || error "$@"; exit 0; }
+## this function ins taken and cleaned from configure_networking
+find_nic_by_mac() {
+		# look for devices with matching mac address, and set RET if found.
+		local mac="$1" curmac="" device="" found=""
+		case "$mac" in
+			*[A-Z]*) mac=$(echo "$mac" | awk '{print(tolower($0))}')
+		esac
+		set +f
+		for device in /sys/class/net/* ; do
+			[ -f "$device/address" ] || continue
+			read curmac < "$device/address" || continue
+			[ "$curmac" = "$mac" ] && found="${device##*/}" && break
+		done
+		set -f
+		[ -n "$found" ] && _RET=$found && return 0
+		return 1
+}
+
+bootif2macaddr() {
+	# bootif is specified as BOOTIF=01-${mac_address} with '-' rather than ':'
+	local input="$1" tok oifs="$IFS"
+	input=${input#??-}
+	IFS="-"
+	_RET=""
+	for tok in $input; do
+		_RET="${_RET}:${tok}"
+	done
+	IFS="$oifs"
+	_RET=${_RET#:}
+}
+
+nic2bootif() {
+	local nic="$1" macaddr="" tok="" oifs="$IFS"
+	[ -f "/sys/class/net/$nic/address" ] || return 1
+	read macaddr < "/sys/class/net/$nic/address"
+	IFS=":"
+	_RET="01"
+	for tok in $macaddr; do
+		_RET="${_RET}-${tok}"
+	done
+	IFS="$oifs"
+}
+
+read CMDLINE < /proc/cmdline
+
+# if BOOTIF_DEFAULT was present on the kernel cmdline, but no BOOTIF was
+# provided then we set BOOTIF based on the network device *name* in
+# BOOTIF_DEFAULT (BOOTIF_DEFAULT=eth0).  This allows a pxe boot implementation
+# without the ability or knowledge to specify IPAPPEND to function.
+bootif_new=""
+if [ -z "$BOOTIF" ]; then
+	for tok in $CMDLINE; do
+		case "$tok" in
+			BOOTIF_DEFAULT=*)
+				wait_for_udev 10
+				nic2bootif "${tok#BOOTIF_DEFAULT=}" || {
+					echo "WARNING: ${0##*/}: no device $tok"
+					continue
+				}
+				BOOTIF=${_RET}
+				bootif_new=${BOOTIF}
+				;;
+		esac
+	done
+fi
+
+# if hostname= is on the cmdline and IP=="dhcp", then change IP to
+#    ::::$hostname:BOOTIF:dhcp
+# This allows old code that specified 'ip=dhcp' to still convince ipconfig to
+# use a given hostname in dhcp request without requiring '::::$hostname:'.
+# The '::::$hostname:' without a device name means "wait for all network
+# devices".  If some are not plugged in, then it will hang for quite some time.
+#
+# This is really a specific kludge to deal with newer maas needing to operating
+# with existing original images from 12.04.  Those images were not able to
+# accept 'ip::::$hostname:BOOTIF' as they did not have this package installed.
+if [ -n "$BOOTIF" -a "$IP" = "dhcp" ]; then
+	for tok in $CMDLINE; do
+		case "$tok" in
+			hostname=*) IP="::::${tok#hostname=}:BOOTIF:dhcp"
+		esac
+	done
+fi
+
+# no IP or IP not containing BOOTIF means nothing to do
+case $IP in
+	*BOOTIF*) :;;
+	*) exit 0
+esac
+
+[ -n "$BOOTIF" ] || fail "WARNING: IP='$IP' but no BOOTIF set!"
+
+## we need to "fix" an IP= string that contains 'BOOTIF'
+## to instead reference the actual interface.
+wait_for_udev 10
+
+bootif2macaddr "$BOOTIF" && [ -n "$_RET" ] ||
+	fail "failed to convert BOOTIF='$BOOTIF'";
+macaddr=${_RET}
+
+find_nic_by_mac "$macaddr" && [ -n "$_RET" ] ||
+	fail "did no find a nic with $macaddr"
+devname=${_RET}
+
+# now replace occurences of BOOTIF in $IP with $devname
+cur="$IP"
+while [ "${cur#*BOOTIF}" != "$cur" ]; do
+   cur="${cur%%BOOTIF*}$devname${cur#*BOOTIF}"
+done
+new=$cur
+
+# get the global variables IP and BOOTIF reset with updated values
+{
+	echo "IP='$new'"
+	[ -z "$bootif_new" ] || echo "BOOTIF='${bootif_new}'"
+} > /conf/param.conf
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/dyn-netconf/scripts/init-top/cloud-initramfs-dyn-netconf 0.46ubuntu1/dyn-netconf/scripts/init-top/cloud-initramfs-dyn-netconf
--- 0.18.debian8/dyn-netconf/scripts/init-top/cloud-initramfs-dyn-netconf	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/dyn-netconf/scripts/init-top/cloud-initramfs-dyn-netconf	1970-01-01 00:00:00.000000000 +0000
@@ -1,125 +0,0 @@
-#!/bin/sh
-set -e
-set -f
-
-PREREQS="udev"
-case $1 in
-	prereqs) echo "${PREREQS}"; exit 0;;
-esac
-
-. /scripts/functions
-
-PATH=/usr/sbin:/usr/bin:/sbin:/bin
-
-error() { echo "${0##*/}:" "$@" 1>&2; }
-fail() { [ $# -eq 0 ] || error "$@"; exit 0; }
-## this function ins taken and cleaned from configure_networking
-find_nic_by_mac() {
-		# look for devices with matching mac address, and set DEVICE to
-		# appropriate value if match is found.
-		local mac="$1" curmac="" device="" found=""
-		set +f
-		for device in /sys/class/net/* ; do
-			[ -f "$device/address" ] || continue
-			read curmac < "$device/address" || continue
-			[ "$curmac" = "$mac" ] && found="${device##*/}" && break
-		done
-		set -f
-		[ -n "$found" ] && _RET=$found && return 0
-		return 1
-}
-
-bootif2macaddr() {
-	# bootif is specified as BOOTIF=01-${mac_address} with '-' rather than ':'
-	local input="$1" tok oifs="$IFS"
-	input=${input#??-}
-	IFS="-"
-	_RET=""
-	for tok in $input; do
-		_RET="${_RET}:${tok}"
-	done
-	IFS="$oifs"
-	_RET=${_RET#:}
-}
-
-nic2bootif() {
-	local nic="$1" macaddr="" tok="" oifs="$IFS"
-	[ -f "/sys/class/net/$nic/address" ] || return 1
-	read macaddr < "/sys/class/net/$nic/address"
-	IFS=":"
-	_RET="01"
-	for tok in $macaddr; do
-		_RET="${_RET}-${tok}"
-	done
-	IFS="$oifs"
-}
-
-read CMDLINE < /proc/cmdline
-
-# if BOOTIF_DEFAULT was present on the kernel cmdline, but no BOOTIF was
-# provided then we set BOOTIF based on the network device *name* in
-# BOOTIF_DEFAULT (BOOTIF_DEFAULT=eth0).  This allows a pxe boot implementation
-# without the ability or knowledge to specify IPAPPEND to function.
-bootif_new=""
-if [ -z "$BOOTIF" ]; then
-	for tok in $CMDLINE; do
-		case "$tok" in
-			BOOTIF_DEFAULT=*)
-				wait_for_udev 10
-				nic2bootif "${tok#BOOTIF_DEFAULT=}" || {
-					echo "WARNING: ${0##*/}: no device $tok"
-					continue
-				}
-				BOOTIF=${_RET}
-				bootif_new=${BOOTIF}
-				;;
-		esac
-	done
-fi
-
-# if hostname= is on the cmdline and IP=="dhcp", then change IP to
-#    ::::$hostname:BOOTIF:dhcp
-# This allows old code that specified 'ip=dhcp' to still convince ipconfig to
-# use a given hostname in dhcp request without requiring '::::$hostname:'.
-# The '::::$hostname:' without a device name means "wait for all network
-# devices".  If some are not plugged in, then it will hang for quite some time.
-#
-# This is really a specific kludge to deal with newer maas needing to operating
-# with existing original images from 12.04.  Those images were not able to
-# accept 'ip::::$hostname:BOOTIF' as they did not have this package installed.
-if [ -n "$BOOTIF" -a "$IP" = "dhcp" ]; then
-	for tok in $CMDLINE; do
-		case "$tok" in
-			hostname=*) IP="::::${tok#hostname=}:BOOTIF:dhcp"
-		esac
-	done
-fi
-
-# no IP or IP not containing BOOTIF means nothing to do
-case $IP in
-	*BOOTIF*) :;;
-	*) exit 0
-esac
-
-[ -n "$BOOTIF" ] || fail "WARNING: IP='$IP' but no BOOTIF set!"
-
-## we need to "fix" an IP= string that contains 'BOOTIF'
-## to instead reference the actual interface.
-wait_for_udev 10
-
-bootif2macaddr "$BOOTIF" && [ -n "$_RET" ] ||
-	fail "failed to convert BOOTIF='$BOOTIF'";
-macaddr=${_RET}
-
-find_nic_by_mac "$macaddr" && [ -n "$_RET" ] ||
-	fail "did no find a nic with $macaddr"
-devname=${_RET}
-
-new=$(echo "$IP" | sed "s,BOOTIF,$devname,g")
-
-{
-	echo "IP='$new'" 
-	[ -z "$bootif_new" ] || echo "BOOTIF='${bootif_new}'"
-} > /conf/param.conf
-
-# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/growroot/doc/example.txt 0.46ubuntu1/growroot/doc/example.txt
--- 0.18.debian8/growroot/doc/example.txt	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/growroot/doc/example.txt	2020-08-13 20:47:40.000000000 +0000
@@ -66,17 +66,17 @@ On a Eucalyptus kvm instance, I did the
   read by the kernel and we can make a new filesystem on /dev/sda2 and
   put some things in it.
   $ sudo mkfs.ext3 /dev/sda2 -L HIMOM
-  $ sudo  mount /dev/sda2 /mnt 
+  $ sudo  mount /dev/sda2 /mnt
   $ sudo rsync -a /etc /mnt/
 
-  
+
 - Reboot the system, and the ramdisk should resize the root partition
   However, in order to make filesystem know about its larger size, we
   have to run resize2fs.  That can be done by cloud-init.  So that
   cloud-init does that on first boot, remove the marker that it has
   already done so.
   $ sudo rm /etc/growroot-disabled
-  $ sudo rm /var/lib/cloud/instance/sem/config-resizefs 
+  $ sudo rm /var/lib/cloud/instance/sem/config-resizefs
   $ sudo reboot
 
 - After reboot, the partition table should look like the 'new sfdisk -d'
diff -pruN 0.18.debian8/growroot/dracut/modules.d/50growroot/growroot.sh 0.46ubuntu1/growroot/dracut/modules.d/50growroot/growroot.sh
--- 0.18.debian8/growroot/dracut/modules.d/50growroot/growroot.sh	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/growroot/dracut/modules.d/50growroot/growroot.sh	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,115 @@
+#!/bin/sh
+
+# Environment variables that this script relies upon:
+# - NEWROOT
+
+. /lib/dracut-lib.sh
+
+_info() {
+	echo "growroot: $*"
+}
+
+_warning() {
+	echo "growroot Warning: $*" >&2
+}
+
+# This will drop us into an emergency shell
+_fatal() {
+	echo "growroot Fatal: $*" >&2
+	exit 1
+}
+
+# This runs right before exec of /sbin/init, the real root is already mounted
+# at NEWROOT
+_growroot()
+{
+	local out rootdev rootmnt rootfs opts unused rootdisk partnum
+
+	# If a file indicates we should do nothing, then just return
+	for file in /var/lib/cloud/instance/root-grown /etc/growroot-disabled \
+		/etc/growroot-grown ; do
+		if [ -f "${NEWROOT}${file}" ] ; then
+			_info "${file} exists, nothing to do"
+			return
+		fi
+	done
+
+	# Get the root device, root filesystem and mount options
+	if ! out=$(awk '$2 == mt { print }' "mt=${NEWROOT}" < /proc/mounts) ; then
+		_warning "${out}"
+		return
+	fi
+
+	# Need to do it this way, can't use '<<< "${out}"' since RHEL6 doesn't
+	# seem to understand it
+	read rootdev rootmnt rootfs opts unused <<EOF
+${out}
+EOF
+	if [ -z "${rootdev}" -o -z "${rootmnt}" -o -z "${rootfs}" -o \
+		-z "${opts}" ] ; then
+		_warning "${out}"
+		return
+	fi
+
+	# If the basename of the root device (ie 'xvda1', 'sda1', 'vda') exists
+	# in /sys/block/ then it is a block device, not a partition
+	if [ -e "/sys/block/${rootdev##*/}" ] ; then
+		_info "${rootdev} is not a partition"
+		return
+	fi
+
+	# Check if the root device is a partition (name ends with a digit)
+	if [ "${rootdev%[0-9]}" = "${rootdev}" ] ; then
+		_warning "${rootdev} is not a partition"
+		return
+	fi
+
+	# Remove all numbers from the end of rootdev to get the rootdisk and
+	# partition number
+	rootdisk=${rootdev}
+	while [ "${rootdisk%[0-9]}" != "${rootdisk}" ] ; do
+		rootdisk=${rootdisk%[0-9]}
+	done
+	partnum=${rootdev#${rootdisk}}
+
+	# Do a growpart dry run and exit if it fails or doesn't have anything to do
+	if ! out=$(growpart --dry-run "${rootdisk}" "${partnum}") ; then
+		_info "${out}"
+		return
+	fi
+
+	# There's something to do so unmount and re-partition
+	if ! umount "${NEWROOT}" ; then
+		_warning "Failed to umount ${NEWROOT}"
+		return
+	fi
+
+	# Wait for any of the initial udev events to finish otherwise growpart
+	# might fail
+	udevsettle
+
+	# Resize the root partition
+	if out=$(growpart "${rootdisk}" "${partnum}" 2>&1) ; then
+		_info "${out}"
+	else
+		_warning "${out}"
+		_warning "growpart failed"
+	fi
+
+	# Wait for the partition re-read events to complete so that the root
+	# partition is available for remounting
+	udevsettle
+
+	# Remount the root filesystem
+	mount -t "${rootfs}" -o "${opts}" "${rootdev}" "${NEWROOT}" || \
+		_fatal "Failed to re-mount ${rootdev}, this is bad"
+
+	# Write to /etc/growroot-grown, most likely this wont work (read-only)
+	{
+		date --utc > "${NEWROOT}/etc/growroot-grown"
+	} >/dev/null 2>&1
+}
+
+_growroot
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/growroot/dracut/modules.d/50growroot/install 0.46ubuntu1/growroot/dracut/modules.d/50growroot/install
--- 0.18.debian8/growroot/dracut/modules.d/50growroot/install	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/growroot/dracut/modules.d/50growroot/install	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,7 @@
+#!/bin/bash
+
+inst_hook pre-pivot 00 "$moddir/growroot.sh"
+
+dracut_install awk
+dracut_install growpart
+dracut_install sfdisk
diff -pruN 0.18.debian8/growroot/dracut/modules.d/50growroot/module-setup.sh 0.46ubuntu1/growroot/dracut/modules.d/50growroot/module-setup.sh
--- 0.18.debian8/growroot/dracut/modules.d/50growroot/module-setup.sh	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/growroot/dracut/modules.d/50growroot/module-setup.sh	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,20 @@
+#!/bin/bash
+
+check() {
+	return 0
+}
+
+depends() {
+	return 0
+}
+
+install() {
+	inst_hook pre-pivot 00 "$moddir/growroot.sh"
+
+	dracut_install awk
+	dracut_install growpart
+	dracut_install sfdisk
+	dracut_install sgdisk
+}
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/growroot/hooks/growroot 0.46ubuntu1/growroot/hooks/growroot
--- 0.18.debian8/growroot/hooks/growroot	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/growroot/hooks/growroot	2020-08-13 20:47:40.000000000 +0000
@@ -9,8 +9,9 @@ esac
 . /usr/share/initramfs-tools/hook-functions
 
 ##
-copy_exec /sbin/sfdisk /sbin
-copy_exec /usr/bin/growpart /sbin
-copy_exec /sbin/udevadm /sbin
+for pname in sfdisk growpart udevadm flock; do
+    fpath=$(which "$pname") && copy_exec "$fpath" ||
+        { echo "ERROR: no '$pname' in path" 1>&2; exit 1; }
+done
 
 # vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/growroot/scripts/local-bottom/growroot 0.46ubuntu1/growroot/scripts/local-bottom/growroot
--- 0.18.debian8/growroot/scripts/local-bottom/growroot	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/growroot/scripts/local-bottom/growroot	2020-08-13 20:47:40.000000000 +0000
@@ -56,15 +56,21 @@ fi
 # if growpart fails, exit.
 # we capture stderr because on success of dry-run, it writes
 # to stderr what it would do.
-out=$(growpart --dry-run "${rootdisk}" "${partnum}" 2>&1) ||
-	{ msg "${out}"; exit 1; }
+out=$(growpart --dry-run "${rootdisk}" "${partnum}" 2>&1)
+ret=$?
 
 # if growpart would change something, --dry-run will write something like
 #  CHANGE: partition=1 start=2048 old: size=1024000 end=1026048 new: size=2089192,end=2091240
-# anything else, exit
-case "${out}" in
-	CHANGE:*) :;;
-	*) exit 0;;
+# newer versions of growpart will exit
+#   0: with 'CHANGE:*' in output on changed
+#   1: with 'NOCHANGE:*' in output on no-change-necessary
+#   2: error occurred
+# older versions of growpart would exit '1' on all failure scenarios
+# or with 'no-change-necessary'
+case "$ret:$out" in
+	0:CHANGE:*) :;;
+	[01]:NOCHANGE:*) exit 0;;
+	*) msg "exited '$ret'" "${out}"; exit 1;;
 esac
 
 # There was something to do, unmount and resize
@@ -88,7 +94,7 @@ else
 	echo "GROWROOT: WARNING: resize failed: $out"
 fi
 
-# Wait for the partition re-read events to complete 
+# Wait for the partition re-read events to complete
 # so that the root partition is available when we try and mount it.
 udevadm settle --timeout ${ROOTDELAY:-30}
 
diff -pruN 0.18.debian8/Makefile 0.46ubuntu1/Makefile
--- 0.18.debian8/Makefile	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/Makefile	2020-08-13 20:47:40.000000000 +0000
@@ -1,4 +1,4 @@
-MODULES = growroot rescuevol overlayroot dyn-netconf
+MODULES = growroot rescuevol overlayroot dyn-netconf copymods rooturl updateroot
 INITRAMFS_D = /usr/share/initramfs-tools
 IRD = $(DESTDIR)/$(INITRAMFS_D)
 ULIB_PRE = $(DESTDIR)/usr/lib/cloud-initramfs-
@@ -18,10 +18,21 @@ install:
 			mkdir -p "$$td" ; \
 			install "$$sd"/* "$$td"; \
 		done; done
+	set -e ; for d in $(MODULES); do \
+		[ -d $$d/conf-hooks.d/ ] || continue; \
+		mkdir -p "$(IRD)/conf-hooks.d"; \
+		install -m 644 "$$d/conf-hooks.d"/* "$(IRD)/conf-hooks.d/" ; \
+		done
 	set -e; for d in $(MODULES); do \
 		[ -d "$$d/etc" ] || continue ; \
-		install -m 644 "$$d/etc"/* "$(DESTDIR)/etc" ; \
-		done
+		for f in $$d/etc/*; do \
+		    if [ -d "$$f" ];then \
+		    		install -m 755 -d "$(DESTDIR)/etc/$${f##*/}" ; \
+				install "$$f"/* "$(DESTDIR)/etc/$${f##*/}" ; \
+				continue ; \
+				fi ;\
+			install -m 644 -t "$(DESTDIR)/etc" "$$f" ;\
+			done; done
 	set -e; for d in $(MODULES); do \
 		[ -d "$$d/tools" ] || continue ; \
 		mkdir -p "$(ULIB_PRE)$$d/" && \
@@ -31,4 +42,24 @@ install:
 	install -m 755 "overlayroot/usr/sbin/overlayroot-chroot" "$(DESTDIR)/usr/sbin"
 	install -m 644 "overlayroot/usr/share/man/man8/overlayroot-chroot.8" "$(DESTDIR)/usr/share/man/man8"
 
+#
+# Fedora/EPEL
+#
+
+DRACUT_GROWROOT_D = dracut/modules.d/50growroot
+
+install-fedora:
+	mkdir -p "$(DESTDIR)/$(DRACUT_GROWROOT_D)"
+	for f in growroot.sh module-setup.sh ; do \
+		install "growroot/$(DRACUT_GROWROOT_D)/$$f" \
+			"$(DESTDIR)/$(DRACUT_GROWROOT_D)/" ; \
+	done
+
+install-epel:
+	mkdir -p "$(DESTDIR)/$(DRACUT_GROWROOT_D)"
+	for f in growroot.sh install ; do \
+		install "growroot/$(DRACUT_GROWROOT_D)/$$f" \
+			"$(DESTDIR)/$(DRACUT_GROWROOT_D)/" ; \
+	done
+
 # vi: ts=4 noexpandtab syntax=make
diff -pruN 0.18.debian8/overlayroot/conf-hooks.d/overlayroot 0.46ubuntu1/overlayroot/conf-hooks.d/overlayroot
--- 0.18.debian8/overlayroot/conf-hooks.d/overlayroot	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/overlayroot/conf-hooks.d/overlayroot	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1 @@
+export CRYPTSETUP=y
diff -pruN 0.18.debian8/overlayroot/etc/overlayroot.conf 0.46ubuntu1/overlayroot/etc/overlayroot.conf
--- 0.18.debian8/overlayroot/etc/overlayroot.conf	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/overlayroot/etc/overlayroot.conf	2020-08-13 20:47:40.000000000 +0000
@@ -48,6 +48,8 @@
 #       the name of the map device to be created in /dev/mapper
 #     * pass: default: ""
 #       if not provided or empty, password is randomly generated
+#       the generated password will be stored for recovery in
+#       /run/initramfs/overlayroot.passwd
 #     * fstype: default: "ext4"
 #       mapname=mapper,pass=foo,fstype=ext4,mkfs=1
 #     * mkfs: default: 1
@@ -98,6 +100,11 @@
 #    default is to use top level directory.  For example, use
 #    'dir=my-tests/run1' and later 'dir=my-tests/run2'
 #
+#  * driver: default: "auto"
+#    This can be 'overlay' or 'overlayfs'.  It will affect which filesystem
+#    is used to provide the overlay and the entries in fstab.
+#    The default value is almost certainly correct.
+#
 # overlayroot_cfgdisk:
 #  * default: 'disabled'
 #    If this variable is set, it references a disk/filesystem that
diff -pruN 0.18.debian8/overlayroot/etc/update-motd.d/97-overlayroot 0.46ubuntu1/overlayroot/etc/update-motd.d/97-overlayroot
--- 0.18.debian8/overlayroot/etc/update-motd.d/97-overlayroot	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/overlayroot/etc/update-motd.d/97-overlayroot	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,4 @@
+#!/bin/sh
+
+(egrep "overlayroot|/media/root-ro|/media/root-rw" /proc/mounts 2>/dev/null | sort -r) || true
+echo
diff -pruN 0.18.debian8/overlayroot/hooks/overlayroot 0.46ubuntu1/overlayroot/hooks/overlayroot
--- 0.18.debian8/overlayroot/hooks/overlayroot	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/overlayroot/hooks/overlayroot	2020-08-13 20:47:40.000000000 +0000
@@ -1,7 +1,7 @@
 #!/bin/sh
 set -e
 
-PREREQS=""
+PREREQS="cryptsetup"
 case $1 in
 	prereqs) echo "${PREREQS}"; exit 0;;
 esac
@@ -16,9 +16,11 @@ copy_exec /sbin/cryptsetup /sbin
 copy_exec /sbin/mke2fs /sbin
 
 manual_add_modules overlayfs
+manual_add_modules overlay
 manual_add_modules dm_mod
 manual_add_modules dm_crypt
-egrep -qswo "aes" /proc/cpuinfo && manual_add_modules aesni_intel || true
+# this is '||' only in case this module isn't built
+manual_add_modules aesni_intel || true
 
 # Grab as much true random data as possible, up to 4KB, and stash it into a
 # random seed in the initramfs
diff -pruN 0.18.debian8/overlayroot/scripts/init-bottom/overlayroot 0.46ubuntu1/overlayroot/scripts/init-bottom/overlayroot
--- 0.18.debian8/overlayroot/scripts/init-bottom/overlayroot	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/overlayroot/scripts/init-bottom/overlayroot	2020-08-13 20:47:40.000000000 +0000
@@ -38,7 +38,7 @@ MYTAG="overlayroot"
 TEMP_D="${TMPDIR:-/tmp}/${0##*/}.configs"
 VARIABLES="overlayroot overlayroot_cfgdisk"
 
-# generic settings 
+# generic settings
 # ${ROOT} and ${rootmnt} are predefined by caller of this script. Note that
 # the root fs ${rootmnt} it mounted readonly on the initrams, which fits
 # nicely for our purposes.
@@ -46,6 +46,17 @@ root_rw=/media/root-rw
 root_ro=/media/root-ro
 ROOTMNT=${rootmnt} # use global name to indicate created outside this
 OVERLAYROOT_DEBUG=0
+# PERSIST_DIR will persist after pivot-root.  It is used for log file
+# and for the mktemp-made password file in crypt.
+PERSIST_DIR=/run/initramfs
+if [ ! -d "$PERSIST_DIR" -a -d /dev/.initramfs ]; then
+	PERSIST_DIR="/dev/.initramfs"
+fi
+if [ ! -d "$PERSIST_DIR" ]; then
+	mkdir -p "$PERSIST_DIR" ||
+		echo "WARNING: $MYTAG: failed to create ${PERSIST_DIR}" 1>&2
+fi
+LOG_FILE="${PERSIST_DIR}/${MYTAG}.log"
 
 log() {
 	"log_${1}_msg" "$MYTAG: $2";
@@ -67,11 +78,12 @@ debug() {
 	echo "$MYTAG:" "$@"
 }
 _debug() {
-	if [ "${DEBUG_BUSTED:-0}" = "0" ]; then
-		{ echo "$@" >> "/dev/.initramfs/${MYTAG}.log"; } 2>/dev/null ||
+	if [ "${DEBUG_BUSTED:-0}" ]; then
+		{ echo "$@" >> "$LOG_FILE"; } 2>/dev/null ||
 			{ DEBUG_BUSTED=1; log_warn "debug is busted"; }
 	fi
 }
+
 safe_string() {
 	local prev="$1" allowed="$2" cur=""
 	[ -n "$prev" ] || return 1
@@ -144,11 +156,16 @@ crypto_setup() {
 	local fstype="ext4" pass="" mapname="secure" mkfs="1" dev=""
 	local timeout=0
 	local entropy_sources="/proc/sys/kernel/random/boot_id /proc/sys/kernel/random/uuid /dev/urandom"
-	local seed=
+	local seed="" rootseed="$ROOTMNT/var/lib/urandom/random-seed"
+	if [ ! -f "$rootseed" -a -f "$ROOTMNT/var/lib/systemd/random-seed" ]; then
+		rootseed="$ROOTMNT/var/lib/systemd/random-seed"
+	fi
 	# Seed the psuedo random number generator with available seeds
-	for seed in "/.random-seed" "${ROOTMNT}/var/lib/urandom/random-seed"; do
-		[ -f "${seed}" ] && cat "${seed}" > /dev/urandom ||
-			{ debug "missing rng seed [${seed}]"; }
+	for seed in "/.random-seed" "$rootseed"; do
+		[ -f "${seed}" ] ||
+			{ debug "missing rng seed [${seed}]"; continue; }
+		cat "${seed}" > /dev/urandom ||
+			debug "failed seeding /dev/urandom from $seed"
 	done
 	# this does necessary crypto setup and sets _RET
 	# to the appropriate block device (ie /dev/mapper/secure)
@@ -205,16 +222,21 @@ crypto_setup() {
 		[ "$mkfs" = "0" ] &&
 			{ log_fail "mkfs=0, but no password provided"; return 1; }
 		entropy_sources="$entropy_sources $dev"
-		local pass_file=$(mktemp /dev/.initramfs/${MYTAG}.XXXXXX) ||
+		local tmpf="" pass_file="${PERSIST_DIR}/${MYTAG}.passwd"
+		tmpf=$(mktemp "${PERSIST_DIR}/${MYTAG}.XXXXXX") ||
 			{ log_fail "failed creation of password file"; return 1; }
-		stat -L /dev/* /proc/* /sys/* >${pass_file} 2>&1 ||
+		stat -L /dev/* /proc/* /sys/* >"$tmpf" 2>&1 ||
 			{ log_warn "could not seed with stat entropy [$entropy_sources]"; }
-		head -c 4096 $entropy_sources >> ${pass_file} ||
+		head -c 4096 $entropy_sources >> "$tmpf" ||
 			{ log_fail "failed reading entropy [$entropy_sources]"; return 1; }
-		pass=$(sha512sum ${pass_file}) ||
+		pass=$(sha512sum "$tmpf") ||
 			{ log_fail "failed generation of password"; return 1; }
 		pass=${pass%% *}
-		printf "%s" "${pass}" > ${pass_file}
+		printf "%s" "${pass}" > "$tmpf" ||
+			{ log_fail "failed to record password to '$tmpf'"; return 1; }
+		mv "$tmpf" "${pass_file}" ||
+			{ log_fail "failed rename '$tmpf' to '${pass_file}'"; return 1; }
+		log_debug "stored password in ${pass_file}"
 	fi
 
 	log_warn "setting up new luks device at $dev"
@@ -258,62 +280,153 @@ dev_setup() {
 	_RET_DEVICE="$dev"
 }
 
+clean_path() {
+	# remove '//' in a path.
+	local p="$1" tmp=""
+	while [ "${p#*//}" != "$p" ]; do
+		tmp=${p#*//}
+		p="${p%%//*}/${tmp}"
+	done
+	_RET="$p"
+}
+
+get_workdir() {
+	local root_rw="$1" dir_prefix="$2" file="$3"
+	file=${file%/}
+	if [ "$file" = "/" -o "$file" = "" ]; then
+		file="_"
+	fi
+	clean_path "${root_rw}/${dir_prefix%/}-workdir/${file}"
+}
+
+gen_fstab() {
+	# gen_fstab(mp) - generate a fabricated /etc/fstab for mount point $mp
+	local mp="$1" m_spec="" m_opts="" m_fstype=""
+	local spec file vfstype opts pass freq
+
+	# just remove any trailing /
+	[ "$mp" != "/" ] && mp=${mp%/}
+	while read spec file vfstype opts pass freq; do
+		[ "$file" = "$mp" ] && {
+			m_spec="$spec"
+			m_opts="$opts"
+			m_fstype="$vfstype"
+			break
+		}
+	done </proc/mounts
+	[ -z "$m_spec" ] && {
+		log_warn "did not find root mount point $mp in /proc/mounts"
+		m_opts="/dev/root"
+		m_opts="defaults"
+		m_fstype="auto"
+	}
+
+	echo "# fabricated by overlayroot, rootfs did not contain /etc/fstab"
+	echo "${m_spec} / ${m_fstype} ${m_opts} 0 0 "
+}
+
 overlayrootify_fstab() {
 	# overlayrootify_fstab(input, root_ro, root_rw, dir_prefix, recurse, swap)
 	# read input fstab file, write an overlayroot version to stdout
 	# also returns (_RET) a list of directories that will need to be made
 	local input="$1" root_ro="${2:-/media/root-ro}"
 	local root_rw="${3:-/media/root-rw}" dir_prefix="${4:-/}"
-	local recurse=${5:-1} swap=${6:-0}
-	local hash="#" oline="" ospec="" upper="" dirs="" copy_opts=""
-	local vfstypes=" proc sys tmpfs dev udev "
+	local recurse=${5:-1} swap=${6:-0} fstype=${7:-overlayfs}
+	local hash="#" oline="" ospec="" upper="" dirs="" copy_opts="" copy_opt=""
 	local spec file vfstype opts pass freq line ro_line
+	local workdir="" use_orig="" relfile="" needs_workdir=false noauto=""
 	
-	dir_prefix="${dir_prefix#/}"
-
 	[ -f "$input" ] || return 1
+
+    cat <<EOF
+#
+#  This fstab is for overlayroot. The real one can be found at
+#  ${root_ro}/etc/fstab
+#  The original entry for '/' and other mounts have been updated to be placed
+#  under $root_ro.
+#  To permanently modify this (or any other file), you should change-root into
+#  a writable view of the underlying filesystem using:
+#      sudo overlayroot-chroot
+#
+EOF
+
+	needs_workdir && needs_workdir=true || needs_workdir=false
 	while read spec file vfstype opts pass freq; do
+		[ "$file" = "/" ] && noauto="noauto" || noauto=""
 		line="$spec $file $vfstype $opts $pass $freq"
 		case ",$opts," in
 			*,ro,*) ro_opts="$opts";;
 			*) ro_opts="ro,${opts}";;
 		esac
-		ro_line="$spec ${root_ro}$file $vfstype ${ro_opts} $pass $freq"
-		if [ "${spec#${hash}}" != "$spec" ] ||
-		   [ -z "$freq" ]; then
-			# line has a comment in first field, or not 6 fields
-			echo "$line"
-		elif [ "${vfstypes# *${vfstype} }" != "${vfstypes}" ]; then
-			# this is a virtual filesystem, just let it through
-			echo "${line}"
+		ro_line="$spec ${root_ro}$file $vfstype"
+		ro_line="${ro_line} ${ro_opts}${noauto:+,${noauto}} $pass $freq"
+
+		use_orig=""
+		if [ "${spec#${hash}}" != "$spec" ]; then
+			use_orig="comment"
+		elif [ -z "$freq" ]; then
+			use_orig="malformed-line"
+		else
+			case "$vfstype" in
+				vfat|fat) use_orig="fs-unsupported";;
+				proc|sys|tmpfs|dev|udev|debugfs) use_orig="fs-virtual";;
+			esac
+		fi
+
+		if [ -n "$use_orig" ]; then
+			if [ "$use_orig" != "comment" ]; then
+				echo "$line # $MYTAG:$use_orig"
+			else
+				echo "$line"
+			fi
 		elif [ "$vfstype" = "swap" ]; then
 			if [ "$swap" = "0" ]; then
 				# comment out swap lines
-				echo "#overlayroot:swap=${swap}#${line}"
+				echo "#$MYTAG:swap=${swap}#${line}"
 			elif [ "${spec#/}" != "${spec}" ] &&
 			     [ "${spec#/dev/}" = "${spec}" ]; then
 				# comment out swap files (spec starts with / and not in /dev)
-				echo "#overlayroot:swapfile#${line}"
+				echo "#$MYTAG:swapfile#${line}"
 			else
 				echo "${line}"
 			fi
 		else
 			ospec="${root_ro}${file}"
 			copy_opts=""
-			[ "${opts#*nobootwait*}" != "${opts}" ] &&
-				copy_opts=",nobootwait"
-			upper="${root_rw%/}/${dir_prefix%/}${file%/}"
-			oline="${ospec} ${file} overlayfs "
-			oline="${oline}lowerdir=${root_ro}${file},"
-			oline="${oline}upperdir=${upper}${copy_opts} $pass $freq"
+			for copy_opt in nobootwait noauto; do
+				case ",$opts," in
+					*,${copy_opt},*)
+						copy_opts="${copy_opts},${copy_opt}";;
+				esac
+			done
+
+			clean_path "${root_rw}/${dir_prefix}${file}"
+			upper="$_RET"
+
+			oline="${ospec} ${file} $fstype "
+			clean_path "${root_ro}${file}"
+			oline="${oline}lowerdir=$_RET"
+			oline="${oline},upperdir=${upper}${copy_opts}"
+			if [ "$fstype" = "overlayfs" -o "$fstype" = "overlay" ] &&
+				${needs_workdir}; then
+				get_workdir "$root_rw" "$dir_prefix" "$file"
+				workdir="$_RET"
+				oline="${oline},workdir=$workdir"
+				dirs="${dirs} $workdir"
+			fi
+ 			oline="${oline} $pass $freq"
 
-			if [ "$recurse" != "0" ]; then
-				echo "$ro_line"
+			if [ "$recurse" != "0" -o "$file" = "/" ]; then
+				if [ "$file" = "/" ]; then
+					# this can confuse systemd (LP: #1723183)
+					echo "#$ro_line"
+				else
+					echo "$ro_line"
+				fi
 				echo "$oline"
 				dirs="${dirs} ${upper}"
 			else
 				echo "$line"
-				[ "$file" = "/" ] && dirs="${dirs} ${upper}"
 			fi
 		fi
 	done < "$input"
@@ -381,7 +494,7 @@ parse_cfg() {
 	#
 	# known issues:
 	# * sourced file could re-define 'echo'
-	# * just fails if a value has a ' in it 
+	# * just fails if a value has a ' in it
 	[ -f "$1" ] || return 0
 	tick="'" sh -c '
 		__tick=$tick
@@ -398,7 +511,7 @@ parse_cfg() {
 		set -e
 		echo "desc=${__tick}${__desc}${__tick}"
 		for var in ${__vars}; do
-			eval val=\${${var}-${__unset__}} || 
+			eval val=\${${var}-${__unset__}} ||
 				{ echo "eval of $var failed"; exit 1; }
 			[ "${val#*${__tick}}" = "${val}" ] || {
 				echo "variable \"$var\" had single tick in it. fail";
@@ -429,6 +542,65 @@ readcfgd() {
 	set -f
 }
 
+fix_upstart_overlayfs() {
+	# inotify events on an overlayfs underlay do not propogate through
+	# a newly created overlay.  This causes job creation and deletion issues
+	# for upstart, which uses inotify on /etc/init. So ensure that the overlay
+	# explicitly has a /etc/init (LP: #1213925)
+	local root="$1"
+	local initctl="$root/sbin/initctl"
+	local eifile="/etc/init/.overlayfs-upstart-helper"
+
+	[ -e "$initctl" -o -L "$initctl" ] || return 0
+	[ -d "$root/etc/init" ] || return 0
+	echo "#upstart needs help for overlayfs (LP: #1213925)." \
+		> "$root/$eifile" ||
+		{ log_fail "failed to write $root/$eifile"; return 1; }
+	debug "created $eifile under $root (LP: #1213925)"
+}
+
+needs_workdir() {
+	local uname_r="${UNAME_R}"
+	if [ -z "$uname_r" ]; then
+		uname_r=$(uname -r) && UNAME_R="$uname_r" ||
+			{ log_warn "failed to read uname!"; return 2; }
+	fi
+	# 3.18+ require 'workdir=' option.
+	case "${uname_r}" in
+		2*|3.1[01234567]*|3.[0-9].*) return 1;;
+		*) return 0;;
+	esac
+}
+
+
+search_fs_driver() {
+	# search_fs_driver(driver1, driver2...)
+	# return the first supported filesystem driver in the list.
+	# if no drivers are provided, search default list.
+	# assumes that name in /proc/filesystems and module name are the same.
+	local m="" driver="" tab='	'
+	for m in "$@"; do
+		grep -q "${tab}$m$" /proc/filesystems && driver="$m" &&
+			{ debug "/proc/filesystems support for '$m'"; break; }
+	done
+	if [ -z "$driver" ]; then
+		for m in "$@"; do
+			if modprobe -qb "$m"; then
+				if grep -q "${tab}$m$" /proc/filesystems; then
+					debug "loaded module '$m'";
+					driver="$m"
+					break;
+				else
+					log_warn "loaded '$m' module but no '$m' in /proc/filesystems"
+				fi
+			fi
+		done
+	fi
+	[ -n "$driver" ] ||
+		{ debug "Unable to find driver/module. searched: $*"; return 1; }
+	_RET="$driver"
+}
+
 cfgd="${TEMP_D}/configs"
 mkdir -p "${cfgd}" || fail "failed to create tempdir"
 trap cleanup EXIT
@@ -524,27 +696,45 @@ swap=${_RET_common_swap:-0}
 recurse=${_RET_common_recurse:-1}
 OVERLAYROOT_DEBUG=${_RET_common_debug:-${OVERLAYROOT_DEBUG}}
 dir_prefix=${_RET_common_dir:-"/overlay"}
+overlayroot_driver=${_RET_common_driver}
+
+read cmdline </proc/cmdline
+cmdline=" $cmdline "
+[ "${cmdline#* ro }" != "$cmdline" ] && cmdline_ro=true || cmdline_ro=false
+
+if [ "${overlayroot_driver:-auto}" = "auto" ]; then
+	search_fs_driver overlay overlayfs ||
+		fail "Unable to find a driver. searched: overlay overlayfs"
+	overlayroot_driver="$_RET"
+else
+	search_fs_driver ${overlayroot_driver} ||
+		fail "Unable to find a driver named '${overlayroot_driver}'"
+	overlayroot_driver="$_RET"
+fi
 
 debug "swap=$swap recurse=$recurse debug=$OVERLAYROOT_DEBUG dir=$dir_prefix"
-debug "device=$device mode=$mode"
+debug "device=$device mode=$mode driver=${overlayroot_driver}"
 
 [ "$swap" = "0" -o "$swap" = "1" ] ||
 	fail "invalid setting for swap: $swap. must be '0' or '1'"
 [ "$recurse" = "0" -o "$recurse" = "1" ] ||
 	fail "invalid setting for recurse: $recurse. must be '0' or '1'"
 
-log_warn "configuring overlayroot with mode=$mode opts='$opts' per $used_desc"
-
-# overlayroot_driver *could* be defined in one of the configs above
-# but we're not documenting that.
-overlayroot_driver=${overlayroot_driver:-overlayfs}
+log_warn "configuring overlayroot with driver=${overlayroot_driver} mode=$mode opts='$opts' per $used_desc"
 
 # settings based on overlayroot_driver
+workdir=""
 case "${overlayroot_driver}" in
-	overlayfs)
-		mount_type="overlayfs"
+	overlayfs|overlay)
+		mount_type="${overlayroot_driver}"
 		mount_opts="-o lowerdir=${root_ro},upperdir=${root_rw}/${dir_prefix}"
-		mount_opts="${mount_opts} overlayroot ${ROOTMNT}"
+		if needs_workdir; then
+			get_workdir "$root_rw" "$dir_prefix" "/"
+			workdir="$_RET"
+			mount_opts="${mount_opts},workdir=$workdir"
+		fi
+		clean_path "${mount_opts} overlayroot ${ROOTMNT}"
+		mount_opts="$_RET"
 		;;
 	aufs)
 		mount_type="aufs"
@@ -556,10 +746,6 @@ case "${overlayroot_driver}" in
 		;;
 esac
 
-# check if kernel module exists 
-modprobe -qb "${overlayroot_driver}" ||
-	fail "missing kernel module ${overlayroot_driver}"
-
 # make the mount point on the init root fs ${root_rw}
 mkdir -p "${root_rw}" ||
 	fail "failed to create ${root_rw}"
@@ -582,20 +768,25 @@ fi
 mkdir -p "${root_rw}/${dir_prefix}" ||
 	fail "failed to create ${dir_prefix} on ${device}"
 
+[ -z "$workdir" ] || mkdir -p "$workdir" ||
+	fail "failed to create workdir '$workdir' on ${device}"
+
 # root is mounted on ${ROOTMNT}, move it to ${ROOT_RO}.
 mount --move "${ROOTMNT}" "${root_ro}" ||
 	fail "failed to move root away from ${ROOTMNT} to ${root_ro}"
 
 # there is nothing left at ${ROOTMNT} now. So for any error we get we should
 # either do recovery to restore ${ROOTMNT} for drop to a initramfs shell using
-# "panic". Otherwise the boot process is very likely to fail with even more 
-# errors and leave the system in a wired state. 
+# "panic". Otherwise the boot process is very likely to fail with even more
+# errors and leave the system in a wired state.
 
 # mount virtual fs ${ROOTMNT} with rw-fs ${root_rw} on top or ro-fs ${root_ro}.
+debug mount -t "$mount_type" $mount_opts
 mount -t "$mount_type" $mount_opts
 if [ $? -ne 0 ]; then
 	log_fail "failed to create new ro/rw layered ${ROOTMNT}"
-	# do recovery and try resoring the mount for ${ROOTMNT}
+	log_fail "mount command was: mount -t $mount_type $mount_opts"
+	# do recovery and try restoring the mount for ${ROOTMNT}
 	mount --move ${root_ro} ${ROOTMNT}
 	if [ $? -ne 0 ]; then
 		# thats bad, drop to shell to let the user try fixing this
@@ -615,12 +806,12 @@ fi
 # is already up, these changes also end up on ${root_rw} while ${root_ro}
 # is not touched.
 
-# move mount from ${root_ro} to ${ROOTMNT}${root_ro} 
+# move mount from ${root_ro} to ${ROOTMNT}${root_ro}
 mkdir -p "${ROOTMNT}/${root_ro}"
 mount --move ${root_ro} "${ROOTMNT}${root_ro}" ||
 	fail "failed to move ${root_ro} to ${ROOTMNT}${root_ro}"
 
-# move mount from ${root_rw} to ${ROOTMNT}${root_rw} 
+# move mount from ${root_rw} to ${ROOTMNT}${root_rw}
 [ -d ${ROOTMNT}${root_rw} ] || mkdir -p ${ROOTMNT}${root_rw}
 mount --move "${root_rw}" "${ROOTMNT}${root_rw}" ||
 	fail "failed to move ${root_rw} to ${ROOTMNT}${root_rw}"
@@ -628,36 +819,37 @@ mount --move "${root_rw}" "${ROOTMNT}${r
 # technically, everything is set up nicely now. Since ${ROOTMNT} had beend
 # mounted read-only on the initfamfs already, ${ROOTMNT}${root_ro} is it,
 # too.  Now we init process could run - but unfortunately, we may have to
-# prepare some more things here. 
+# prepare some more things here.
 # Basically, there are two ways to deal with the read-only root fs. If the
 # system is made aware of this, things can be simplified a lot.  If it is
-# not, things need to be done to our best knowledge. 
+# not, things need to be done to our best knowledge.
 #
 # So we assume here, the system does not really know about our read-only
 # root fs.
 #
 # Let's deal with /etc/fstab first. It usually contains an entry for the
 # root fs, which is no longer valid now. We have to remove it and add our
-# new ${root_ro} entry. 
+# new ${root_ro} entry.
 # Remember we are still on the initramfs root fs here, so we have to work
 # on ${ROOTMNT}/etc/fstab. The original fstab is
 # ${ROOTMNT}${root_ro}/etc/fstab.
-cat <<EOF >${ROOTMNT}/etc/fstab
-#
-#  This fstab is in an overlayfs.  The real one can be found at
-#  ${root_ro}/etc/fstab
-#  The original entry for '/' and other mounts have been updated to be placed
-#  under $root_ro.
-#  To permanently modify this (or any other file), you should change-root into
-#  a writable view of the underlying filesystem using:
-#      sudo overlayroot-chroot
-#
-EOF
+source_fstab="$ROOTMNT/${root_ro}/etc/fstab"
+if [ ! -f "$source_fstab" ] && [ "$cmdline_ro" = "true" ]; then
+	debug "rootfs did not contain /etc/fstab, creating" \
+		"based on kernel cmdline"
+	source_fstab="${TEMP_D}/fstab"
+	gen_fstab "${ROOTMNT}${root_ro}" > "$source_fstab" ||
+		log_fail "gen_fstab failed for $ROOTMNT/$root_ro"
+fi
 
-[ $? -eq 0 ] || log_fail "failed to modify /etc/fstab (step 1)"
-overlayrootify_fstab ""${ROOTMNT}${root_ro}/etc/fstab"" "$root_ro" \
-	"$root_rw" "$dir_prefix" "$recurse" "$swap" >> "${ROOTMNT}/etc/fstab" ||
-	log_fail "failed to modify /etc/fstab (step 2)"
+if [ -f "$source_fstab" ]; then
+	overlayrootify_fstab "$source_fstab" "$root_ro" \
+		"$root_rw" "$dir_prefix" "$recurse" "$swap" "${overlayroot_driver}" \
+		>> "${ROOTMNT}/etc/fstab" ||
+		log_fail "failed to modify /etc/fstab"
+else
+	debug "rootfs did not contain /etc/fstab."
+fi
 
 # we have to make the directories in ${root_rw} because if they do not
 # exist, then the 'upper=' argument to overlayfs will fail.
@@ -665,11 +857,14 @@ for d in ${_RET}; do
 	mkdir -p "${ROOTMNT}/$d"
 done
 
+if [ "${overlayroot_driver}" = "overlayfs" ]; then
+	fix_upstart_overlayfs "$ROOTMNT" ||
+		log_fail "failed to fix upstart for overlayfs"
+fi
+
 # if / is supposed to be mounted read-only (cmdline with 'ro')
 # then mount our overlayfs as read-only just to be more normal
-read cmdline < /proc/cmdline
-cmdline=" $cmdline "
-if [ "${cmdline#* ro }" != "$cmdline" ]; then
+if [ "${cmdline_ro}" = "true" ]; then
 	mount -o remount,ro "$ROOTMNT" ||
 		log_fail "failed to remount overlayroot read-only"
 	debug "mounted $ROOTMNT read-only per kernel cmdline"
@@ -679,5 +874,5 @@ msg="configured root with '$overlayroot'
 msg="$msg ${used_desc}"
 log_success "$msg"
 
-exit 0 
+exit 0
 # vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/overlayroot/usr/sbin/overlayroot-chroot 0.46ubuntu1/overlayroot/usr/sbin/overlayroot-chroot
--- 0.18.debian8/overlayroot/usr/sbin/overlayroot-chroot	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/overlayroot/usr/sbin/overlayroot-chroot	2020-08-13 20:47:40.000000000 +0000
@@ -31,7 +31,9 @@ info() {
 }
 
 get_lowerdir() {
-	overlay=$(grep -m1 "^overlayroot / overlayfs " /proc/mounts) || overlay=
+	local overlay=""
+	overlay=$(awk \
+		'$1 == "overlayroot" && $2 == "/" { print $0 }' /proc/mounts)
 	if [ -n "${overlay}" ]; then
 		lowerdir=${overlay##*lowerdir=}
 		lowerdir=${lowerdir%%,*}
@@ -71,7 +73,7 @@ for d in proc run sys; do
 	if ! mountpoint "${lowerdir}/${d}" >/dev/null; then
 		mount -o bind "/${d}" "${lowerdir}/${d}" || fail "Unable to bind /${d}"
 		mounts="$mounts $lowerdir/$d"
-		trap "clean_exit \"${mounts}\" || true" EXIT HUP INT QUIT TERM   
+		trap "clean_exit \"${mounts}\" || true" EXIT HUP INT QUIT TERM
 	fi
 done
 
diff -pruN 0.18.debian8/README 0.46ubuntu1/README
--- 0.18.debian8/README	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/README	2020-08-13 20:47:40.000000000 +0000
@@ -44,3 +44,12 @@ and access the system to fix it.
 If the volume contains a file '/etc/rescuevol-ignore' it will be ignored.
 This allows you to fix your instance, create that volume and *not* boot the
 rescue volume on next boot
+
+== overlayroot ==
+Configure overlayfs filesystems over the root device based on
+configuration provided by kernel command line or in-image config.
+
+see overlayroot/etc/overlayroot.conf for more information.
+
+== dyn-netconf ==
+see dyn-netconf/doc/README.txt
diff -pruN 0.18.debian8/rescuevol/scripts/local-premount/rescuevol 0.46ubuntu1/rescuevol/scripts/local-premount/rescuevol
--- 0.18.debian8/rescuevol/scripts/local-premount/rescuevol	2020-03-11 00:30:21.000000000 +0000
+++ 0.46ubuntu1/rescuevol/scripts/local-premount/rescuevol	2020-08-13 20:47:40.000000000 +0000
@@ -11,7 +11,7 @@ get_dev_by_label() {
 	_RET=${dev}
 }
 hasvol() {
-	local dev="" mp="" label=${1} myinit="${2}" 
+	local dev="" mp="" label=${1} myinit="${2}"
 	get_dev_by_label "$label" || return 1
 	dev=${_RET}
 
diff -pruN 0.18.debian8/rooturl/doc/example-boot.sh 0.46ubuntu1/rooturl/doc/example-boot.sh
--- 0.18.debian8/rooturl/doc/example-boot.sh	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/rooturl/doc/example-boot.sh	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,103 @@
+#!/bin/bash
+set -e
+rel=${1:-xenial}
+ftype=${2}
+if [ -z "$ftype" ]; then
+  case "$rel" in
+    precise|trusty) ftype="-root.tar.xz";;
+    *) ftype=".squashfs";;
+  esac
+fi
+name="rooturl-$rel"
+
+which cloud-localds >/dev/null || missing="cloud-image-utils"
+which lxc >/dev/null || missing="${missing} lxc"
+[ -z "$missing" ] ||
+   { echo "Please apt-get install -qy $missing"; exit 1; }
+
+mkdir -p $rel
+
+if ! [ -e "$rel/kernel" -a -e "$rel/initrd" ]; then
+lxc launch ubuntu-daily:$rel "$name"
+trap "lxc delete --force $name" EXIT
+lxc exec "$name" -- sh -s <<"EOF"
+set -e
+while [ ! -e /run/cloud-init/result.json ]; do
+   echo -n .
+   sleep 1
+done
+echo "manual_add_modules squashfs" > /etc/initramfs-tools/hooks/squashfs
+apt-get update -q
+apt-get install -qy cloud-initramfs-rooturl linux-image-virtual </dev/null
+cd /tmp
+for i in /boot/vmlinu?-*; do
+  [ -f "$i" -a "${i%.signed}" != "$i" ] || continue
+done
+cp $i kernel
+for i in /boot/initrd.*; do
+  [ -f "$i" ] || continue
+done
+cp $i initrd
+EOF
+lxc file pull $name/tmp/kernel $rel/kernel
+lxc file pull $name/tmp/initrd $rel/initrd
+fi
+
+burl="http://cloud-images.ubuntu.com/daily/server"
+file="$rel-server-cloudimg-amd64${ftype}"
+cd $rel
+if ! [ -e "$file" ]; then
+   wget "$burl/$rel/current/$file" -O "$file.tmp"
+   mv "$file.tmp" "$file"
+fi
+
+if [ ! -e "user-data" ]; then
+    cat > "user-data" <<EOF
+#cloud-config
+password: passw0rd
+chpasswd: { expire: False }
+ssh_pwauth: True
+EOF
+fi
+
+if [ ! -e "meta-data" ]; then
+   echo "instance-id: $(uuidgen || echo i-abcdefg)" > "meta-data"
+fi
+
+if [ ! -e "seed.img" ]; then
+   cloud-localds seed.img user-data meta-data
+fi
+
+port=9999
+cat > "boot" <<EOF
+#!/bin/sh
+file=\${1:-"${file}"}
+port=\${2:-${port}}
+EOF
+cat >> "boot" <<"EOF"
+cmdline="root=http://10.0.2.2:${port}/$file console=ttyS0"
+case "$file" in
+   *squashfs) cmdline="${cmdline} overlayroot=tmpfs";;
+esac
+
+which python >/dev/null && python=python || python=python3
+$python -m SimpleHTTPServer $port &
+kid=$!
+trap "kill -9 $kid" EXIT
+
+set -x
+qemu-system-x86_64 -enable-kvm \
+  -device virtio-net-pci,netdev=net00 \
+  -netdev type=user,id=net00 \
+  -drive "if=virtio,file=seed.img,format=raw" \
+  -m 1G -nographic \
+  -kernel kernel -initrd initrd \
+  -append "$cmdline"
+EOF
+chmod 755 "boot"
+
+cat <<EOF
+Now, do:
+   cd $rel
+   ./boot
+EOF
diff -pruN 0.18.debian8/rooturl/doc/README.txt 0.46ubuntu1/rooturl/doc/README.txt
--- 0.18.debian8/rooturl/doc/README.txt	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/rooturl/doc/README.txt	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,16 @@
+rooturl is an initramfs module that allows you to download
+a url to a tmpfs and run that as your root.
+
+The supported file types are tar, tar.gz, tar.xz and squashfs.
+
+Ie, you might have a root like that found at
+  http://cloud-images.ubuntu.com/
+
+An example booting squashfs image can be done like:
+
+  qemu-system-x86_64 -enable-kvm
+     -device virtio-net-pci,netdev=net00 \
+     -netdev type=user,id=net00 \
+     -m 1G -nographic \
+     -kernel kernel -initrd initrd \
+     -append "root=http://10.0.2.2:9999/xenial-server-cloudimg-amd64.squashfs console=ttyS0 -v overlayroot=tmpfs break=bottom,init"
diff -pruN 0.18.debian8/rooturl/hooks/rooturl 0.46ubuntu1/rooturl/hooks/rooturl
--- 0.18.debian8/rooturl/hooks/rooturl	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/rooturl/hooks/rooturl	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,24 @@
+#!/bin/sh
+set -e
+
+PREREQS=""
+case $1 in
+    prereqs) echo "${PREREQS}"; exit 0;;
+esac
+
+. /usr/share/initramfs-tools/hook-functions
+
+needs="tar xz" #gzip gunzip"
+for need in $needs; do fp=$(which $need) && copy_exec "$fp" /bin; done
+
+## The busybox versions of gzip and gunzip are sufficient, so use them rather
+## than the full programs via copy_exec.  However, because of odd behavior in
+## initramfs-tools, if we put symlinks in /bin, then
+## initramfs-tools/hooks/busybox will remove them.  So instead, use /sbin
+bbox="gzip gunzip"
+[ -d "$DESTDIR/sbin" ] || mkdir -p "$DESTDIR/sbin"
+for need in $bbox; do ln -sf ../bin/busybox "$DESTDIR/sbin/$need"; done
+
+manual_add_modules squashfs
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/rooturl/scripts/local-top/rooturl 0.46ubuntu1/rooturl/scripts/local-top/rooturl
--- 0.18.debian8/rooturl/scripts/local-top/rooturl	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/rooturl/scripts/local-top/rooturl	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,102 @@
+#!/bin/sh
+#  Copyright, 2016 Scott Moser <smoser@ubuntu.com>
+#
+#  This program is free software: you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation, either version 3 of the License, or
+#  (at your option) any later version.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see
+#    <http://www.gnu.org/licenses/>.
+
+PREREQS=""
+case $1 in
+	prereqs) echo "${PREREQS}"; exit 0;;
+esac
+
+VERBOSITY="1"
+
+debug() {
+	local v=$1
+	shift
+	[ $v -lt $VERBOSITY ] && return 0
+	echo "::" "$@"
+}
+log_warn() { log_warning_msg "$*"; }
+
+mount_tar() {
+	local target="$1" url=""
+	shift;
+	mount -t tmpfs ${ROOTFLAGS} root_url "$target" || return
+
+	local zopt=""
+	for url in "$@"; do
+		case "$url" in
+			*.tar.gz|*.tgz) zopt="z";;
+			*.tar.xz|*.txz) zopt="J";;
+		esac
+		debug 1 "# [$zopt] $url"
+		wget "$url" -O - | tar -C "$target" -xp${zopt}f -
+	done
+	[ -x "$target/sbin" ]
+}
+
+mount_squash() {
+	local target="$1" url="$2"
+	if [ $# -gt 2 ]; then
+		log_warn "too many arguments to mount_squash: $*"
+		return 1
+	fi
+	debug 1 "mount_squash downloading $url to $target.img"
+	wget "$url" -O "$target.img"
+	debug 1 "mount -t squashfs -o loop ${ROOTFLAGS}" \
+		"'$target.img' '$target'"
+	mount -t squashfs -o loop ${ROOTFLAGS} \
+		"$target.img" "$target" || return
+}
+
+mount_url() {
+	local target="$1" urls="$2" firsturl="" helper=""
+	local oifs="$IFS"
+	IFS=","; set -- $urls; IFS="$oifs"
+	firsturl="$1"
+	shift
+
+	case "$firsturl" in
+		tar:http*) helper=mount_tar; firsturl="${firsturl#*:}";;
+		squash:http*) helper=mount_squash; firsturl="${firsturl#*:}";;
+		*.tar.??|*.t?z) helper=mount_tar;;
+		*squash|*squashfs) helper=mount_squash;;
+	esac
+	if [ -z "$helper" ]; then
+		log_warn "no helper identified for '$firsturl'"
+		return 1
+	fi
+	[ -d "$target" ] || mkdir -p "$target" || return
+	"$helper" "$target" "$firsturl" "$@"
+}
+
+. /scripts/functions
+
+case "$ROOT" in
+	http://*|*:http://*) :;;
+	*) exit 0
+esac
+configure_networking || exit
+
+debug 1 "root=$ROOT"
+mount_url "${rootmnt}.tmp" "$ROOT" || exit
+
+{
+	echo 'ROOTFSTYPE="root_url"'
+	echo "ROOTFLAGS=\"-o move\""
+	echo "ROOT=\"$rootmnt.tmp\""
+} > /conf/param.conf
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/updateroot/doc/README.txt 0.46ubuntu1/updateroot/doc/README.txt
--- 0.18.debian8/updateroot/doc/README.txt	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/updateroot/doc/README.txt	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,69 @@
+updateroot is an initramfs module that allows you to update
+the root filesystem before changing to it.
+
+Each updateroot= on the kernel command line will be downloaded
+and extracted over the top of the root filesystem.  Support is
+present for gzip, xz or no compression as long as urls end in
+.tar.gz, .tgz, .tar.xz, .txz or .tar.
+
+Any files in a .updateroot/ directory inside the tarball that
+are executable will be executed inside the target before
+init is started.
+
+To demo this, first install the cloud-initramfs-updateroot and
+cloud-initramfs-rooturl packages.  That will update your initramfs
+to have these modules.
+
+$ sudo dpkg -i cloud-initramfs-updateroot_*.deb clodu-initramfs-rooturl*.deb
+update-initramfs: Generating /boot/initrd.img-4.4.0-23-generic
+$ sudo update-initramfs -u -k $(uname -r)
+
+# make local copies for permissions and shorter cmdline
+$ sudo cat /boot/vmlinu?-$(uname -r) > kernel
+$ cp /boot/initrd.img-$(uname -r) initrd
+
+# create 'seed.tar' with a nocloud seed
+$ cat > user-data <<EOF
+#cloud-config
+password: passw0rd
+chpasswd: { expire: False }
+ssh_pwauth: True
+EOF
+$ echo "instance-id: $(uuidgen || echo i-abcdefg)" > meta-data
+$ cloud-localds --disk-format=tar-seed-local seed.tar user-data meta-data
+
+# download the latest xenial squashfs
+$ iurl="http://cloud-images.ubuntu.com/daily/server/xenial/20160523"
+$ wget "$iurl/xenial-server-cloudimg-amd64.squashfs"
+
+# serve those files on a python simple web server note that
+# 10.0.2.2 works for the host address in a qemu user mode networking
+$ python -m SimpleHTTPServer 9999 &
+$ burl="http://10.0.2.2:9999"
+
+# set cmdline variable
+$ cmdline="root=$burl/xenial-server-cloudimg-amd64.squashfs"
+$ cmdline="$cmdline updateroot=$burl/seed.tar"
+$ cmdline="$cmdline overlayroot=tmpfs"
+$ cmdline="$cmdline console=ttyS0 -v"
+
+# now boot a qemu guest with no disks and 1G memory.
+$ qemu-system-x86_64 -enable-kvm \
+   -device virtio-net-pci,netdev=net00 \
+   -netdev type=user,id=net00 \
+   -m 1G -nographic -kernel kernel -initrd initrd \
+   -append "$cmdline"
+
+The system should boot to a login prompt and let you in as 'ubuntu:passw0rd'
+
+Log in and you'll see something like:
+
+$ df -h /
+Filesystem      Size  Used Avail Use% Mounted on
+overlayroot     497M   59M  438M  12% /
+
+$ egrep "(/media|overlay)" /proc/mounts
+/dev/loop0 /media/root-ro squashfs ro,relatime 0 0
+tmpfs-root /media/root-rw tmpfs rw,relatime 0 0
+overlayroot / overlayfs rw,relatime,lowerdir=/media/root-ro,upperdir=/media/root-rw//overlay,workdir=/media/root-rw//overlay-workdir 0 0
+
diff -pruN 0.18.debian8/updateroot/hooks/updateroot 0.46ubuntu1/updateroot/hooks/updateroot
--- 0.18.debian8/updateroot/hooks/updateroot	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/updateroot/hooks/updateroot	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,26 @@
+#!/bin/sh
+set -e
+
+prereqs() {
+	local o="/scripts/init-bottom/overlayroot"  p=""
+	for p in "$DESTDIR/" ""; do
+		[ -e "$p$o" ] && echo "overlayroot" && return 0
+	done
+}
+
+[ "$1" = "prereqs" ] && { prereqs; exit; }
+
+. /usr/share/initramfs-tools/hook-functions
+
+needs="tar xz" #gzip gunzip"
+for need in $needs; do fp=$(which $need) && copy_exec "$fp" /bin; done
+
+## The busybox versions of gzip and gunzip are sufficient, so use them rather
+## than the full programs via copy_exec.  However, because of odd behavior in
+## initramfs-tools, if we put symlinks in /bin, then
+## initramfs-tools/hooks/busybox will remove them.  So instead, use /sbin
+bbox="gzip gunzip"
+[ -d "$DESTDIR/sbin" ] || mkdir -p "$DESTDIR/sbin"
+for need in $bbox; do ln -sf ../bin/busybox "$DESTDIR/sbin/$need"; done
+
+# vi: ts=4 noexpandtab
diff -pruN 0.18.debian8/updateroot/scripts/init-bottom/updateroot 0.46ubuntu1/updateroot/scripts/init-bottom/updateroot
--- 0.18.debian8/updateroot/scripts/init-bottom/updateroot	1970-01-01 00:00:00.000000000 +0000
+++ 0.46ubuntu1/updateroot/scripts/init-bottom/updateroot	2020-08-13 20:47:40.000000000 +0000
@@ -0,0 +1,163 @@
+#!/bin/sh
+#  Copyright, 2016 Scott Moser <smoser@ubuntu.com>
+#
+#  This program is free software: you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation, either version 3 of the License, or
+#  (at your option) any later version.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see
+#    <http://www.gnu.org/licenses/>.
+VERBOSITY="1"
+
+prereqs() {
+	local o="/scripts/init-bottom/overlayroot"  p=""
+	# basically we run after overlayroot but do not depend on it
+	for p in "$DESTDIR/" ""; do
+		[ -e "$p$o" ] && echo "overlayroot" && return 0
+	done
+}
+
+[ "$1" != "prereqs" ] || { prereqs; exit; }
+
+setf() {
+	# setf 0|1
+	#  set pathname expansion (-f) off or on
+	#     off is an alias for 0
+	#     on is an alias for 1
+	#  stores the current setting in the unscoped variable 'setf'
+	#  returns the previous setting:
+	#     0 if pathname expansion was off
+	#     1 if pathname expansion was on
+	# setf restore [setting]
+	#  restore pathname expansion to 'setting'.
+	#  if setting is not provided, defaults to variable 'setf'
+	if [ "$1" = "restore" ]; then
+		local val=${2:-${setf:-"-"}}
+		[ "$val" = "0" ] && val="-" || val="+"
+		set ${val}f
+		return
+	fi
+
+	local f="" n="0" d=/ r="1"
+	setf="+"
+	for f in "$d/"*; do
+		[ $n -gt 1 ] && break
+		n=$(($n+1))
+	done
+	[ $n -eq 1 -a "$f" = "$d/*" ] && setf="-" && r="0"
+	case "$1" in
+		off|0) set -f;;
+		on|1) set +f;;
+	esac
+	return $r
+}
+
+debug() {
+	local v=$1
+	shift
+	[ $v -lt $VERBOSITY ] && return 0
+	echo "::" "$@"
+}
+
+log_warn() { log_warning_msg "$*"; }
+
+extract_urls() {
+	local target="$1" url="" zopt="" script="" fails="" ret=""
+	shift
+	for url in "$@"; do
+		case "$url" in
+			*.tar.gz|*.tgz) zopt="z";;
+			*.tar.xz|*.txz) zopt="J";;
+			*) zopt="";;
+		esac
+		debug 1 "# updateroot [$zopt] $url"
+		wget "$url" -O - | tar -C "$target" -xp${zopt}f -
+	done
+	if [ ! -d "$target/.updateroot" ]; then
+		return 0
+	fi
+
+	fails=0
+	setf on; set -- "$target/.updateroot/"*; setf restore
+	for script in "$@"; do
+		[ -f "$script" -a -x "$script" ] || continue
+		debug 1 "running ${script#$target} in target root"
+		chroot "$target" "${script#$target}" || {
+			fails=$(($fails+1))
+			ret=$?
+			log_warn "script '${script#$target/}' exited $ret"
+		}
+	done
+	[ $fails -eq 0 ]
+}
+
+apply_updateroot() {
+	local rootmnt="$1" cmdline="$2" ret=""
+	local cmdline urls
+	if [ "$cmdline" = "" ]; then
+		if ! read cmdline < /proc/cmdline; then
+			log_warn "no /proc/cmdline?"
+			return 1
+		fi
+	fi
+	setf off; set -- $cmdline; setf restore
+	for tok in "$@"; do
+		case "$tok" in
+			updateroot=http://*) urls="${urls} ${tok#*=}";;
+		esac
+	done
+	urls=${urls# }
+
+	setf off; set -- $urls; setf restore
+	if [ $# -eq 0 ]; then
+		debug 1 "no updateroot urls configured in cmdline"
+		return 0
+	fi
+
+	if ! configure_networking; then
+		log_warn "failed configuring networking [$?]"
+		return 1
+	fi
+
+	# only mount rw if not already rw
+	local need_remount="false" ret=0 created=true
+	local tfile="$rootmnt/.updateroot.touch"
+	[ -e "$tfile" ] || created=false
+	if ! ( : >> "$tfile" ) >/dev/null 2>&1; then
+		mount -o remount,rw "$rootmnt"
+		ret=$?
+		if $created; then
+			rm -f "$tfile"
+		fi
+		if [ $ret -ne 0 ]; then
+			log_warn "failed mount '$rootmnt' as rw [$ret]."
+			return 1;
+		fi
+		need_remount="true"
+	fi
+
+	extract_urls "$rootmnt" "$@"
+	ret=$?
+
+	if $need_remount; then
+		mount -o remount,ro "$rootmnt" || {
+			log_warn "failed remounting root '$rootmnt' as ro [$?]!"
+			return 1
+		}
+	fi
+
+	return $ret
+}
+
+. /scripts/functions
+
+apply_updateroot "$rootmnt"
+
+# vi: ts=4 noexpandtab
